﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Xenon.KifuNarabe
{


    /// <summary>
    /// プレイ関連
    /// </summary>
    public abstract class Actions_Play
    {


        private static void AppendKifu_ByStep(MasuBango mbfAppend, Uc_Main uc_Main)
        {
            MasuBango previousMasu = uc_Main.Kifu.Last;

            //------------------------------
            // 符号の追加
            //------------------------------
            MasuBango newMasuBangoFugo;
            uc_Main.Kifu.AddAndRefresh(
                mbfAppend,
                //iFugo1Append,
                out newMasuBangoFugo
                );
            View_Fugo iFugo2New = Translator_MasuToFugo1.TranslateMasuToFugo1(newMasuBangoFugo, uc_Main.KomaCollection, uc_Main.Kifu);

            //------------------------------
            // 動く駒検索
            //------------------------------
            Button_Koma foundKoma;

            //----------
            // 駒台から “打”
            //----------
            if (DaHyoji.Visible == iFugo2New.DaHyoji)//newMasuBangoFugo.Fugo.DaHyoji
            {
                foundKoma = uc_Main.KomaCollection.FindKomaBySyuruiIgnoreCase(
                    newMasuBangoFugo.SrcOkiba,// Okiba.SHOGIBAN,
                    iFugo2New.KomaSyurui
                    );
            }
            //----------
            // 将棋盤から
            //----------
            else
            {
                foundKoma = uc_Main.KomaCollection.FindKomaByDestination(
                    newMasuBangoFugo.Sengo,
                    newMasuBangoFugo,
                    iFugo2New.KomaSyurui,
                    iFugo2New.MigiHidari,
                    iFugo2New.AgaruHiku
                    );
            }

            if (null != foundKoma)
            {
                //----------
                // 成り   ＜実行＞
                //----------
                KomaSyurui syurui2;
                switch (iFugo2New.Nari)
                {
                    case NariFunari.Nari:
                        syurui2 = foundKoma.Masu.ToNariCase();
                        break;
                    case NariFunari.Funari:
                        syurui2 = foundKoma.Masu.ToFunariCase();
                        break;
                    default:
                        syurui2 = foundKoma.Masu.Syurui;
                        break;
                }

                //------------------------------
                // 駒移動
                //------------------------------
                Actions_Play.MoveKoma(
                    foundKoma,
                    new MasuBango(
                        newMasuBangoFugo.Sengo,
                        newMasuBangoFugo.Okiba,
                        newMasuBangoFugo.SrcOkiba,
                        newMasuBangoFugo.Suji,
                        newMasuBangoFugo.Dan,
                        newMasuBangoFugo.SrcSuji,
                        newMasuBangoFugo.SrcDan,
                        syurui2,
                        syurui2
                        ),
                    uc_Main
                    );
            }


            //------------------------------
            // 再描画
            //------------------------------
            foreach (Button_Koma koma in uc_Main.KomaCollection.Kyokumen.Items)
            {
                Actions_Koma.RefreshKomaLocation(koma, uc_Main.Shogiban, uc_Main.KomadaiArr, uc_Main);
            }


            //------------------------------
            // 符号表示
            //------------------------------

            View_Fugo fugoView = Translator_MasuToFugo1.TranslateMasuToFugo1(newMasuBangoFugo, uc_Main.KomaCollection, uc_Main.Kifu);
            uc_Main.LblFugo.Text = fugoView.ToString(true, newMasuBangoFugo, previousMasu);

            MasuBango last = uc_Main.Kifu.Last;
            uc_Main.GameState.ChangeTurn( last.Suji, last.Dan, uc_Main);
        }

        /// <summary>
        /// [コマ送り]ボタン
        /// </summary>
        public static void AppendKifu_Komaokuri(Kifu appendKifu, Uc_Main uc_Main)
        {
            MasuBango first;
            appendKifu.PopFirst(out first);

            if (null == first)
            {
                goto gt_EndMethod;
            }
           
            Kifu kifu2 = new Kifu();
            MasuBango newMasuBangoFugo;
            kifu2.AddAndRefresh(
                first,
                out newMasuBangoFugo
                );

            foreach (MasuBango mbfAppend in kifu2.MasuBangoList)
            {
                //------------------------------------------------------------
                // 1手ずつ
                //------------------------------------------------------------
                Actions_Play.AppendKifu_ByStep(mbfAppend, uc_Main);
            }

            uc_Main.OutputKifu();

            uc_Main.AppendInputText(new Kifu1View(appendKifu).ToText(uc_Main.KomaCollection, uc_Main.Kifu));

        gt_EndMethod:
            ;
        }

        /// <summary>
        /// [再生]ボタン
        /// </summary>
        public static void AppendKifu_Saisei(Uc_Main uc_Main)
        {
            Kifu kifuForAppend;
            string restText;

            // 棋譜がなくなるまで続けます。
            while (Notation1Importer.TranslateTextToKifu(uc_Main.GetInputText(), out restText, out kifuForAppend, uc_Main.Kifu, uc_Main.KomaCollection, uc_Main.GameState))
            {
                uc_Main.SetInputText(restText);


                foreach (MasuBango mbfAppend in kifuForAppend.MasuBangoList)
                {
                    //------------------------------------------------------------
                    // 1手ずつ
                    //------------------------------------------------------------
                    Actions_Play.AppendKifu_ByStep(mbfAppend, uc_Main);

                }
            }
        }



        /// <summary>
        /// 棋譜最後の駒の成／不成を切り替えます。
        /// </summary>
        public static void Nari_KifuLast(Button_Koma btnKoma, Uc_Main uc_Main)
        {
            MasuBango last;
            uc_Main.Kifu.PopLast(out last);

            View_Fugo lastFugo = Translator_MasuToFugo1.TranslateMasuToFugo1(last, uc_Main.KomaCollection, uc_Main.Kifu);


            if (null != lastFugo)
            {
                // 最後の符号の成／不成も変えます。

                if (btnKoma.Masu.Nari)
                {
                    //------------------------------
                    // 成→不成
                    //------------------------------
                    btnKoma.Masu = new MasuBango(
                        btnKoma.Masu.Sengo,
                        btnKoma.Masu.Okiba,
                        btnKoma.Masu.SrcOkiba,
                        btnKoma.Masu.Suji,
                        btnKoma.Masu.Dan,
                        btnKoma.Masu.SrcSuji,
                        btnKoma.Masu.SrcDan,
                        btnKoma.Masu.ToFunariCase(),//不成
                        btnKoma.Masu.SrcSyurui
                        );

                    MasuBango newMasuBangoFugo;
                    uc_Main.Kifu.AddAndRefresh(
                        last,
                        out newMasuBangoFugo
                    );
                }
                else
                {
                    //------------------------------
                    // 不成→成
                    //------------------------------
                    btnKoma.Masu = new MasuBango(
                        btnKoma.Masu.Sengo,
                        btnKoma.Masu.Okiba,
                        btnKoma.Masu.SrcOkiba,
                        btnKoma.Masu.Suji,
                        btnKoma.Masu.Dan,
                        btnKoma.Masu.SrcSuji,
                        btnKoma.Masu.SrcDan,
                        btnKoma.Masu.ToNariCase(),//成り
                        btnKoma.Masu.SrcSyurui
                        );

                    MasuBango newMasuBangoFugo;
                    uc_Main.Kifu.AddAndRefresh(
                        last,
                        out newMasuBangoFugo
                        );
                }
            }


            //----------
            // 駒の選択解除
            //----------
            btnKoma.Deselect();


            Actions_Koma.RefreshKomaLocation(btnKoma, uc_Main.Shogiban, uc_Main.KomadaiArr, uc_Main);

            uc_Main.OutputKifu();

            uc_Main.Refresh();
        }


        /// <summary>
        /// 駒を移動させます。
        /// </summary>
        public static void MoveKoma(
            Button_Koma btnKoma,
            MasuBango dst,
            Uc_Main uc_Main
            )
        {
            //----------
            // 将棋盤上のその場所に駒はあるか
            //----------
            Button_Koma underKoma = uc_Main.KomaCollection.Kyokumen.AtMasuDokodemo(Okiba.SHOGIBAN, dst);//盤上
            if (null != underKoma)
            {
                // 駒があったとき
                //>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>

                // その駒は、駒置き場に移動させます。
                MasuBango masu2;
                switch (btnKoma.Masu.Sengo)
                {
                    case Sengo.GOTE:

                        masu2 = Actions_Koma.GetKomadaiSpace(Okiba.GOTE_KOMADAI, uc_Main);
                        if (null != masu2)
                        {
                            // 駒台に空きスペースがありました。
                            //>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>

                            masu2 = new MasuBango(
                                Sengo.GOTE,
                                Okiba.GOTE_KOMADAI,//駒台へ
                                Okiba.SHOGIBAN,//盤上から
                                masu2
                                );
                            underKoma.Masu.MoveTo(masu2);
                        }
                        else
                        {
                            // エラー：　駒台に空きスペースがありませんでした。
                            //>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>

                            MasuBango newMasu = new MasuBango(
                                Sengo.GOTE,
                                Okiba.GOTE_KOMADAI,
                                Okiba.ERROR,
                                1,
                                1,
                                MasuBango.ERROR_SUJI,
                                MasuBango.ERROR_DAN,
                                KomaSyurui.KOMADAI_NI_NAKATTA,
                                KomaSyurui.KOMADAI_NI_NAKATTA
                                );
                            underKoma.Masu.MoveTo( newMasu);
                        }

                        Actions_Koma.RefreshKomaLocation(underKoma, uc_Main.Shogiban, uc_Main.KomadaiArr, uc_Main);
                        break;

                    case Sengo.SENTE://thru
                    default:

                        masu2 = Actions_Koma.GetKomadaiSpace(Okiba.SENTE_KOMADAI, uc_Main);
                        if (null != masu2)
                        {
                            // 駒台に空きスペースがありました。
                            //>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>

                            MasuBango newMasu = new MasuBango(
                                Sengo.SENTE,
                                Okiba.SENTE_KOMADAI,//駒台へ
                                Okiba.SHOGIBAN,//盤上から
                                masu2
                                );
                            underKoma.Masu.MoveTo(newMasu);
                        }
                        else
                        {
                            // エラー：　駒台に空きスペースがありませんでした。
                            //>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>

                            MasuBango newMasu = new MasuBango(
                                Sengo.SENTE,
                                Okiba.SENTE_KOMADAI,
                                Okiba.ERROR,
                                1,
                                1,
                                MasuBango.ERROR_SUJI,
                                MasuBango.ERROR_DAN,
                                KomaSyurui.KOMADAI_NI_NAKATTA,
                                KomaSyurui.KOMADAI_NI_NAKATTA
                                );
                            underKoma.Masu.MoveTo(newMasu);
                        }

                        Actions_Koma.RefreshKomaLocation(underKoma, uc_Main.Shogiban, uc_Main.KomadaiArr, uc_Main);
                        break;
                }

                //------------------------------
                // 成りは解除。
                //------------------------------
                switch (underKoma.Masu.Okiba)
                {
                    // 駒台へ移動しました
                    //>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
                    case Okiba.SENTE_KOMADAI://thru
                    case Okiba.GOTE_KOMADAI:

                        KomaSyurui syurui2 = underKoma.Masu.ToFunariCase();

                        underKoma.Masu = new MasuBango(
                            underKoma.Masu.Sengo,
                            underKoma.Masu.Okiba,
                            underKoma.Masu.SrcOkiba,
                            underKoma.Masu.Suji,
                            underKoma.Masu.Dan,
                            underKoma.Masu.SrcSuji,
                            underKoma.Masu.SrcDan,
                            syurui2,
                            syurui2
                            );

                        break;
                }
            }

            //------------------------------
            // 駒移動
            //------------------------------
            //
            //      選択している駒を、その場所に移動させます。
            //
            btnKoma.Masu.MoveTo(
                new MasuBango(
                    btnKoma.Masu.Sengo,
                    dst.Okiba,
                    btnKoma.Masu.SrcOkiba,// Okiba.SHOGIBAN,//盤上から
                    dst
                    )
                );


            Actions_Koma.RefreshKomaLocation(btnKoma, uc_Main.Shogiban, uc_Main.KomadaiArr, uc_Main);


            uc_Main.Refresh();
        }
    }


}
