﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Xenon.KifuNarabe
{
    public abstract class Translator_TextToProcess
    {

        /// <summary>
        /// 
        /// </summary>
        /// <param name="srcAll">候補マス</param>
        /// <param name="komas"></param>
        /// <returns></returns>
        private static bool Hit(Sengo sengo, KomaSyurui syurui, List<MasuBango> srcAll, KomaCollection komas, out Button_Koma found)
        {
            bool hit = false;
            found = null;

            foreach (MasuBango masu in srcAll)//筋・段。（先後、種類は入っていません）
            {
                foreach (Button_Koma btnKoma in komas.Kyokumen.Items)//全駒
                {
                    if (sengo==btnKoma.Masu.Sengo
                        && syurui==btnKoma.Masu.Syurui
                        && masu.MatchMasu(btnKoma.Masu)
                        )
                    {
                        // 候補マスにいた
                        //>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
                        hit = true;
                        found = btnKoma;
                        break;
                    }
                }
            }

            return hit;
        }
        
        /// <summary>
        /// 符号１「▲６８銀上」を元に、「7968」を作ります。
        /// 
        /// ＜再生、コマ送りで呼び出されます＞
        /// </summary>
        /// <returns></returns>
        public static void TranslateTextToProcess(
            string strSengo, //▲△
            string strSuji, //123…9、１２３…９、一二三…九
            string strDan, //123…9、１２３…９、一二三…九
            string strDou, // “同”
            string strSrcSyurui, //(歩|香|桂|…
            string strMigiHidari,           // 右|左…
            string strAgaruHiku, // 上|引
            string strNariFunari, //成|不成
            string strDaHyoji, //打
            out KomaSyurui srcSyurui,
            out MasuBango process,
            KomaCollection komas,
            Kifu baseKifu,
            GameState gameState
            )
        {
            //------------------------------
            // 符号確定
            //------------------------------
            MigiHidari migiHidari = Converter.StrToMigiHidari(strMigiHidari);
            AgaruHiku agaruHiku = Converter.StrToAgaruHiku(strAgaruHiku);            // 上|引
            NariFunari nariFunari = Converter.NariToBool(strNariFunari);//成
            DaHyoji daHyoji = Converter.StrToDaHyoji(strDaHyoji);             //打

            srcSyurui = Converter.MojiToSyurui(strSrcSyurui);


            //------------------------------
            // 
            //------------------------------
            Sengo sengo = Converter.SengoToEnum(strSengo);


            int suji;
            int dan;

            if ("同" == strDou)
            {
                // 1手前の筋、段を求めます。
                suji = gameState.IttemaeSuji;
                dan = gameState.IttemaeDan;


                ////MasuBango lastMasu = baseKifu.Last;
                ////if (null != lastMasu)
                ////{
                ////    suji = lastMasu.Suji;
                ////    dan = lastMasu.Dan;
                ////}
                ////else
                ////{
                // TODO: こっちは削除したい。
                //suji = MasuBango.DOU_SUJI;
                //dan = MasuBango.DOU_DAN;
                ////}
            }
            else
            {
                suji = Converter.SujiToInt(strSuji);
                dan = Converter.SujiToInt(strDan);
            }

            Okiba srcOkiba = Okiba.SHOGIBAN;
            if (DaHyoji.Visible == daHyoji)
            {
                if (Sengo.GOTE == sengo)
                {
                    srcOkiba = Okiba.GOTE_KOMADAI;
                }
                else
                {
                    srcOkiba = Okiba.SENTE_KOMADAI;
                }
            }

            MasuBango dst1 = new MasuBango(
                sengo,
                Okiba.SHOGIBAN,
                srcOkiba,//Okiba.SHOGIBAN
                suji,
                dan,
                MasuBango.ITTEMAE_KYOKUMEN_SUJI,
                MasuBango.ITTEMAE_KYOKUMEN_DAN,
                //srcSyurui,//このdstSyuruiは、srcSyuruiと同じ
                srcSyurui,
                KomaSyurui.UNKNOWN
                );

            Button_Koma found = null;

            //----------
            // 駒台の駒を打つなら
            //----------
            bool utsu = false;//駒台の駒を打つなら真
            if (DaHyoji.Visible == daHyoji)
            {
                utsu = true;
                goto gt_EndShogiban;
            }


            switch (srcSyurui)
            {
                #region 歩
                //************************************************************
                // 歩
                //************************************************************
                case KomaSyurui.FU:
                    {
                        //----------
                        // 候補マス
                        //----------
                        //┌─┬─┬─┐
                        //│  │  │  │
                        //├─┼─┼─┤
                        //│  │至│  │
                        //├─┼─┼─┤
                        //│  │Ｅ│  │
                        //└─┴─┴─┘
                        bool isE = true;

                        List<MasuBango> srcAll = new List<MasuBango>();
                        if (isE) { srcAll.AddRange(KomanoKidou.SrcE_Oh(sengo, dst1)); }

                        if (Translator_TextToProcess.Hit(sengo, srcSyurui, srcAll, komas, out found))
                        {
                            srcOkiba = Okiba.SHOGIBAN;
                            goto gt_EndSyurui;
                        }
                    }
                    break;
                #endregion

                #region 飛
                //************************************************************
                // 飛
                //************************************************************
                case KomaSyurui.HISYA:
                    {
                        //----------
                        // 候補マス
                        //----------
                        //  ┌─┬─┬─┬─┬─┬─┬─┬─┬─┬─┬─┬─┬─┬─┬─┬─┬─┐
                        //  │  │  │  │  │  │  │  │  │A7│  │  │  │  │  │  │  │  │
                        //  ├─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┤
                        //  │  │  │  │  │  │  │  │  │A6│  │  │  │  │  │  │  │  │
                        //  ├─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┤
                        //  │  │  │  │  │  │  │  │  │A5│  │  │  │  │  │  │  │  │
                        //  ├─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┤
                        //  │  │  │  │  │  │  │  │  │A4│  │  │  │  │  │  │  │  │
                        //  ├─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┤
                        //　│  │  │  │  │  │  │  │  │A3│  │  │  │  │  │  │  │  │
                        //  ├─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┤
                        //  │  │  │  │  │  │  │  │  │A2│  │  │  │  │  │  │  │  │
                        //  ├─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┤
                        //  │  │  │  │  │  │  │  │  │A1│  │  │  │  │  │  │  │  │
                        //  ├─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┤
                        //  │  │  │  │  │  │  │  │  │A0│  │  │  │  │  │  │  │  │
                        //  ├─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┤
                        //  │G7│G6│G5│G4│G3│G2│G1│G0│至│C0│C1│C2│C3│C4│C5│C6│C7│
                        //  ├─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┤
                        //  │  │  │  │  │  │  │  │  │E0│  │  │  │  │  │  │  │  │
                        //  ├─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┤
                        //  │  │  │  │  │  │  │  │  │E1│  │  │  │  │  │  │  │  │
                        //  ├─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┤
                        //  │  │  │  │  │  │  │  │  │E2│  │  │  │  │  │  │  │  │
                        //  ├─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┤
                        //  │  │  │  │  │  │  │  │  │E3│  │  │  │  │  │  │  │  │
                        //  ├─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┤
                        //　│  │  │  │  │  │  │  │  │E4│  │  │  │  │  │  │  │  │
                        //  ├─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┤
                        //  │  │  │  │  │  │  │  │  │E5│  │  │  │  │  │  │  │  │
                        //  ├─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┤
                        //  │  │  │  │  │  │  │  │  │E6│  │  │  │  │  │  │  │  │
                        //  ├─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┤
                        //  │  │  │  │  │  │  │  │  │E7│  │  │  │  │  │  │  │  │
                        //  └─┴─┴─┴─┴─┴─┴─┴─┴─┴─┴─┴─┴─┴─┴─┴─┴─┘
                        bool isA = true;
                        bool isC = true;
                        bool isE = true;
                        bool isG = true;

                        switch(agaruHiku)
                        {
                            case AgaruHiku.Yoru:
                                isA = false;
                                isE = false;
                                break;
                            case AgaruHiku.Agaru:
                                isA = false;
                                isC = false;
                                isG = false;
                                break;
                            case AgaruHiku.Hiku:
                                isC = false;
                                isE = false;
                                isG = false;
                                break;
                        }

                        switch (migiHidari)
                        {
                            case MigiHidari.Migi:
                                isA = false;
                                isE = false;
                                isG = false;
                                break;
                            case MigiHidari.Hidari:
                                isA = false;
                                isC = false;
                                isE = false;
                                break;
                            case MigiHidari.Sugu:
                                isA = false;
                                isC = false;
                                isG = false;
                                break;
                        }

                        List<MasuBango> srcAll = new List<MasuBango>();
                        if (isA){srcAll.AddRange(KomanoKidou.SrcA_Hisya(sengo, dst1));}
                        if (isC){srcAll.AddRange(KomanoKidou.SrcC_Hisya(sengo, dst1));}
                        if (isE){srcAll.AddRange(KomanoKidou.SrcE_Hisya(sengo, dst1));}
                        if (isG){srcAll.AddRange(KomanoKidou.SrcG_Hisya(sengo, dst1));}

                        if (Translator_TextToProcess.Hit(sengo, srcSyurui, srcAll, komas, out found))
                        {
                            srcOkiba = Okiba.SHOGIBAN;
                            goto gt_EndSyurui;
                        }
                    }
                    break;
                #endregion

                #region 角
                //************************************************************
                // 角
                //************************************************************
                case KomaSyurui.KAKU:
                    {
                        //----------
                        // 候補マス
                        //----------
                        //  ┌─┬─┬─┬─┬─┬─┬─┬─┬─┬─┬─┬─┬─┬─┬─┬─┬─┐
                        //  │H7│  │  │  │  │  │  │  │  │  │  │  │  │  │  │  │B7│
                        //  ├─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┤
                        //  │  │H6│  │  │  │  │  │  │  │  │  │  │  │  │  │B6│  │
                        //  ├─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┤
                        //  │  │  │H5│  │  │  │  │  │  │  │  │  │  │  │B5│  │  │
                        //  ├─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┤
                        //  │  │  │  │H4│  │  │  │  │  │  │  │  │  │B4│  │  │  │
                        //  ├─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┤
                        //　│  │  │  │  │H3│  │  │  │  │  │  │  │B3│  │  │  │  │
                        //  ├─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┤
                        //  │  │  │  │  │  │H2│  │  │  │  │  │B2│  │  │  │  │  │
                        //  ├─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┤
                        //  │  │  │  │  │  │  │H1│  │  │  │B1│  │  │  │  │  │  │
                        //  ├─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┤
                        //  │  │  │  │  │  │  │  │H0│  │B0│  │  │  │  │  │  │  │
                        //  ├─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┤
                        //  │  │  │  │  │  │  │  │  │至│  │  │  │  │  │  │  │  │
                        //  ├─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┤
                        //  │  │  │  │  │  │  │  │F0│  │D0│  │  │  │  │  │  │  │
                        //  ├─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┤
                        //  │  │  │  │  │  │  │F1│  │  │  │D1│  │  │  │  │  │  │
                        //  ├─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┤
                        //  │  │  │  │  │  │F2│  │  │  │  │  │D2│  │  │  │  │  │
                        //  ├─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┤
                        //  │  │  │  │  │F3│  │  │  │  │  │  │  │D3│  │  │  │  │
                        //  ├─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┤
                        //　│  │  │  │F4│  │  │  │  │  │  │  │  │  │D4│  │  │  │
                        //  ├─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┤
                        //  │  │  │F5│  │  │  │  │  │  │  │  │  │  │  │D5│  │  │
                        //  ├─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┤
                        //  │  │F6│  │  │  │  │  │  │  │  │  │  │  │  │  │D6│  │
                        //  ├─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┤
                        //  │F7│  │  │  │  │  │  │  │  │  │  │  │  │  │  │  │D7│
                        //  └─┴─┴─┴─┴─┴─┴─┴─┴─┴─┴─┴─┴─┴─┴─┴─┴─┘
                        bool isB = true;
                        bool isD = true;
                        bool isF = true;
                        bool isH = true;

                        switch (agaruHiku)
                        {
                            case AgaruHiku.Yoru:
                                isB = false;
                                isD = false;
                                isF = false;
                                isH = false;
                                break;
                            case AgaruHiku.Agaru:
                                isB = false;
                                isH = false;
                                break;
                            case AgaruHiku.Hiku:
                                isB = false;
                                isH = false;
                                break;
                        }

                        switch (migiHidari)
                        {
                            case MigiHidari.Migi:
                                isF = false;
                                isH = false;
                                break;
                            case MigiHidari.Hidari:
                                isB = false;
                                isD = false;
                                break;
                            case MigiHidari.Sugu:
                                isD = false;
                                isF = false;
                                break;
                        }

                        List<MasuBango> srcAll = new List<MasuBango>();
                        if (isB) { srcAll.AddRange(KomanoKidou.SrcB_Kaku(sengo, dst1)); }
                        if (isD) { srcAll.AddRange(KomanoKidou.SrcD_Kaku(sengo, dst1)); }
                        if (isF) { srcAll.AddRange(KomanoKidou.SrcF_Kaku(sengo, dst1)); }
                        if (isH) { srcAll.AddRange(KomanoKidou.SrcH_Kaku(sengo, dst1)); }

                        //----------
                        // 候補マスＢ
                        //----------
                        if (Translator_TextToProcess.Hit(sengo, srcSyurui, srcAll, komas, out found))
                        {
                            srcOkiba = Okiba.SHOGIBAN;
                            goto gt_EndSyurui;
                        }
                    }
                    break;
                #endregion

                #region 香
                //************************************************************
                // 香
                //************************************************************
                case KomaSyurui.KYO:
                    {
                        //----------
                        // 候補マス
                        //----------
                        //  ┌─┬─┬─┐
                        //  │  │至│  │
                        //  ├─┼─┼─┤
                        //  │  │E0│  │
                        //  ├─┼─┼─┤
                        //  │  │E1│  │
                        //  ├─┼─┼─┤
                        //  │  │E2│  │
                        //  ├─┼─┼─┤
                        //  │  │E3│  │
                        //  ├─┼─┼─┤
                        //  │  │E4│  │
                        //  ├─┼─┼─┤
                        //  │  │E5│  │
                        //  ├─┼─┼─┤
                        //  │  │E6│  │
                        //  ├─┼─┼─┤
                        //  │  │E7│  │
                        //  └─┴─┴─┘
                        bool isE = true;

                        List<MasuBango> srcAll = new List<MasuBango>();
                        if (isE) { srcAll.AddRange(KomanoKidou.SrcE_Hisya(sengo, dst1)); }

                        if (Translator_TextToProcess.Hit(sengo, srcSyurui, srcAll, komas, out found))
                        {
                            srcOkiba = Okiba.SHOGIBAN;
                            goto gt_EndSyurui;
                        }
                    }
                    break;
                #endregion

                #region 桂
                //************************************************************
                // 桂
                //************************************************************
                case KomaSyurui.KEI:
                    {
                        //----------
                        // 候補マス
                        //----------
                        //┌─┐　┌─┐
                        //│  │　│  │
                        //├─┼─┼─┤
                        //│　│  │  │
                        //├─┼─┼─┤
                        //│　│至│  │先手から見た図
                        //├─┼─┼─┤
                        //│　│  │  │
                        //├─┼─┼─┤
                        //│Ｊ│　│Ｉ│
                        //└─┘　└─┘
                        bool isI = true;
                        bool isJ = true;

                        switch (agaruHiku)
                        {
                            case AgaruHiku.Yoru:
                                isI = false;
                                isJ = false;
                                break;
                            case AgaruHiku.Agaru:
                                break;
                            case AgaruHiku.Hiku:
                                isI = false;
                                isJ = false;
                                break;
                        }

                        switch (migiHidari)
                        {
                            case MigiHidari.Migi:
                                isJ = false;
                                break;
                            case MigiHidari.Hidari:
                                isI = false;
                                break;
                            case MigiHidari.Sugu:
                                isI = false;
                                isJ = false;
                                break;
                        }

                        List<MasuBango> srcAll = new List<MasuBango>();
                        if (isI) { srcAll.AddRange(KomanoKidou.SrcI_Kei(sengo, dst1)); }
                        if (isJ) { srcAll.AddRange(KomanoKidou.SrcJ_Kei(sengo, dst1)); }

                        if (Translator_TextToProcess.Hit(sengo, srcSyurui, srcAll, komas, out found))
                        {
                            srcOkiba = Okiba.SHOGIBAN;
                            goto gt_EndSyurui;
                        }
                    }
                    break;
                #endregion


                #region 銀
                //************************************************************
                // 銀
                //************************************************************
                case KomaSyurui.GIN:
                    {
                        //----------
                        // 候補マス
                        //----------
                        //┌─┬─┬─┐
                        //│Ｈ│  │Ｂ│
                        //├─┼─┼─┤
                        //│　│至│  │先手から見た図
                        //├─┼─┼─┤
                        //│Ｆ│Ｅ│Ｄ│
                        //└─┴─┴─┘
                        bool isB = true;
                        bool isD = true;
                        bool isE = true;
                        bool isF = true;
                        bool isH = true;

                        switch (agaruHiku)
                        {
                            case AgaruHiku.Yoru:
                                isB = false;
                                isD = false;
                                isE = false;
                                isF = false;
                                isH = false;
                                break;
                            case AgaruHiku.Agaru:
                                isB = false;
                                isH = false;
                                break;
                            case AgaruHiku.Hiku:
                                isD = false;
                                isE = false;
                                isF = false;
                                break;
                        }

                        switch (migiHidari)
                        {
                            case MigiHidari.Migi:
                                isE = false;
                                isF = false;
                                isH = false;
                                break;
                            case MigiHidari.Hidari:
                                isB = false;
                                isD = false;
                                isE = false;
                                break;
                            case MigiHidari.Sugu:
                                isB = false;
                                isD = false;
                                isF = false;
                                isH = false;
                                break;
                        }

                        List<MasuBango> srcAll = new List<MasuBango>();
                        if (isB) { srcAll.AddRange(KomanoKidou.SrcB_Oh(sengo, dst1)); }
                        if (isD) { srcAll.AddRange(KomanoKidou.SrcD_Oh(sengo, dst1)); }
                        if (isE) { srcAll.AddRange(KomanoKidou.SrcE_Oh(sengo, dst1)); }
                        if (isF) { srcAll.AddRange(KomanoKidou.SrcF_Oh(sengo, dst1)); }
                        if (isH) { srcAll.AddRange(KomanoKidou.SrcH_Oh(sengo, dst1)); }

                        if (Translator_TextToProcess.Hit(sengo, srcSyurui, srcAll, komas, out found))
                        {
                            srcOkiba = Okiba.SHOGIBAN;
                            goto gt_EndSyurui;
                        }
                    }
                    break;
                #endregion

                #region △金、△と金、△成香、△成桂、△成銀
                //************************************************************
                // △金、△と金、△成香、△成桂、△成銀
                //************************************************************
                case KomaSyurui.KIN:
                case KomaSyurui.TOKIN:
                case KomaSyurui.NARIKYO:
                case KomaSyurui.NARIKEI:
                case KomaSyurui.NARIGIN:
                    {
                        //----------
                        // 候補マス
                        //----------
                        //┌─┬─┬─┐
                        //│  │Ａ│  │
                        //├─┼─┼─┤
                        //│Ｇ│至│Ｃ│先手から見た図
                        //├─┼─┼─┤
                        //│Ｆ│Ｅ│Ｄ│
                        //└─┴─┴─┘
                        bool isA = true;
                        bool isC = true;
                        bool isD = true;
                        bool isE = true;
                        bool isF = true;
                        bool isG = true;

                        switch (agaruHiku)
                        {
                            case AgaruHiku.Yoru:
                                isA = false;
                                isD = false;
                                isE = false;
                                isF = false;
                                break;
                            case AgaruHiku.Agaru:
                                isA = false;
                                isC = false;
                                isG = false;
                                break;
                            case AgaruHiku.Hiku:
                                isC = false;
                                isD = false;
                                isE = false;
                                isF = false;
                                isG = false;
                                break;
                        }

                        switch (migiHidari)
                        {
                            case MigiHidari.Migi:
                                isA = false;
                                isE = false;
                                isF = false;
                                isG = false;
                                break;
                            case MigiHidari.Hidari:
                                isA = false;
                                isC = false;
                                isD = false;
                                isE = false;
                                break;
                            case MigiHidari.Sugu:
                                isA = false;
                                isC = false;
                                isD = false;
                                isF = false;
                                isG = false;
                                break;
                        }

                        List<MasuBango> srcAll = new List<MasuBango>();
                        if (isA) { srcAll.AddRange(KomanoKidou.SrcA_Oh(sengo, dst1)); }
                        if (isC) { srcAll.AddRange(KomanoKidou.SrcC_Oh(sengo, dst1)); }
                        if (isD) { srcAll.AddRange(KomanoKidou.SrcD_Oh(sengo, dst1)); }
                        if (isE) { srcAll.AddRange(KomanoKidou.SrcE_Oh(sengo, dst1)); }
                        if (isF) { srcAll.AddRange(KomanoKidou.SrcF_Oh(sengo, dst1)); }
                        if (isG) { srcAll.AddRange(KomanoKidou.SrcG_Oh(sengo, dst1)); }

                        if (Translator_TextToProcess.Hit(sengo, srcSyurui, srcAll, komas, out found))
                        {
                            srcOkiba = Okiba.SHOGIBAN;
                            goto gt_EndSyurui;
                        }
                    }
                    break;
                #endregion

                #region 王
                //************************************************************
                // 王
                //************************************************************
                case KomaSyurui.OH:
                    {
                        //----------
                        // 候補マス
                        //----------
                        //┌─┬─┬─┐
                        //│Ｈ│Ａ│Ｂ│
                        //├─┼─┼─┤
                        //│Ｇ│至│Ｃ│先手から見た図
                        //├─┼─┼─┤
                        //│Ｆ│Ｅ│Ｄ│
                        //└─┴─┴─┘
                        bool isA = true;
                        bool isB = true;
                        bool isC = true;
                        bool isD = true;
                        bool isE = true;
                        bool isF = true;
                        bool isG = true;
                        bool isH = true;

                        List<MasuBango> srcAll = new List<MasuBango>();
                        if (isA) { srcAll.AddRange(KomanoKidou.SrcA_Oh(sengo, dst1)); }
                        if (isB) { srcAll.AddRange(KomanoKidou.SrcB_Oh(sengo, dst1)); }
                        if (isC) { srcAll.AddRange(KomanoKidou.SrcC_Oh(sengo, dst1)); }
                        if (isD) { srcAll.AddRange(KomanoKidou.SrcD_Oh(sengo, dst1)); }
                        if (isE) { srcAll.AddRange(KomanoKidou.SrcE_Oh(sengo, dst1)); }
                        if (isF) { srcAll.AddRange(KomanoKidou.SrcF_Oh(sengo, dst1)); }
                        if (isG) { srcAll.AddRange(KomanoKidou.SrcG_Oh(sengo, dst1)); }
                        if (isH) { srcAll.AddRange(KomanoKidou.SrcH_Oh(sengo, dst1)); }

                        // 王は１つです。
                        if (Translator_TextToProcess.Hit(sengo, srcSyurui, srcAll, komas, out found))
                        {
                            srcOkiba = Okiba.SHOGIBAN;
                            goto gt_EndSyurui;
                        }
                    }
                    break;
                #endregion

                #region 竜
                //************************************************************
                // 竜
                //************************************************************
                case KomaSyurui.RYU:
                    {
                        //----------
                        // 候補マス
                        //----------
                        //  ┌─┬─┬─┬─┬─┬─┬─┬─┬─┬─┬─┬─┬─┬─┬─┬─┬─┐
                        //  │  │  │  │  │  │  │  │  │A7│  │  │  │  │  │  │  │  │
                        //  ├─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┤
                        //  │  │  │  │  │  │  │  │  │A6│  │  │  │  │  │  │  │  │
                        //  ├─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┤
                        //  │  │  │  │  │  │  │  │  │A5│  │  │  │  │  │  │  │  │
                        //  ├─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┤
                        //  │  │  │  │  │  │  │  │  │A4│  │  │  │  │  │  │  │  │
                        //  ├─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┤
                        //　│  │  │  │  │  │  │  │  │A3│  │  │  │  │  │  │  │  │
                        //  ├─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┤
                        //  │  │  │  │  │  │  │  │  │A2│  │  │  │  │  │  │  │  │
                        //  ├─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┤
                        //  │  │  │  │  │  │  │  │  │A1│  │  │  │  │  │  │  │  │
                        //  ├─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┤
                        //  │  │  │  │  │  │  │  │Ｈ│A0│Ｂ│  │  │  │  │  │  │  │
                        //  ├─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┤
                        //  │G7│G6│G5│G4│G3│G2│G1│G0│至│C0│C1│C2│C3│C4│C5│C6│C7│
                        //  ├─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┤
                        //  │  │  │  │  │  │  │  │Ｆ│E0│Ｄ│  │  │  │  │  │  │  │
                        //  ├─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┤
                        //  │  │  │  │  │  │  │  │  │E1│  │  │  │  │  │  │  │  │
                        //  ├─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┤
                        //  │  │  │  │  │  │  │  │  │E2│  │  │  │  │  │  │  │  │
                        //  ├─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┤
                        //  │  │  │  │  │  │  │  │  │E3│  │  │  │  │  │  │  │  │
                        //  ├─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┤
                        //　│  │  │  │  │  │  │  │  │E4│  │  │  │  │  │  │  │  │
                        //  ├─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┤
                        //  │  │  │  │  │  │  │  │  │E5│  │  │  │  │  │  │  │  │
                        //  ├─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┤
                        //  │  │  │  │  │  │  │  │  │E6│  │  │  │  │  │  │  │  │
                        //  ├─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┤
                        //  │  │  │  │  │  │  │  │  │E7│  │  │  │  │  │  │  │  │
                        //  └─┴─┴─┴─┴─┴─┴─┴─┴─┴─┴─┴─┴─┴─┴─┴─┴─┘
                        bool isA = true;
                        bool isB = true;
                        bool isC = true;
                        bool isD = true;
                        bool isE = true;
                        bool isF = true;
                        bool isG = true;
                        bool isH = true;

                        switch (agaruHiku)
                        {
                            case AgaruHiku.Yoru:
                                isA = false;
                                isB = false;
                                isD = false;
                                isE = false;
                                isF = false;
                                isH = false;
                                break;
                            case AgaruHiku.Agaru:
                                isA = false;
                                isB = false;
                                isC = false;
                                isG = false;
                                isH = false;
                                break;
                            case AgaruHiku.Hiku:
                                isC = false;
                                isD = false;
                                isE = false;
                                isF = false;
                                isG = false;
                                break;
                        }

                        switch (migiHidari)
                        {
                            case MigiHidari.Migi:
                                isA = false;
                                isE = false;
                                isF = false;
                                isG = false;
                                isH = false;
                                break;
                            case MigiHidari.Hidari:
                                isA = false;
                                isB = false;
                                isC = false;
                                isD = false;
                                isE = false;
                                break;
                            case MigiHidari.Sugu:
                                isA = false;
                                isB = false;
                                isC = false;
                                isD = false;
                                isF = false;
                                isG = false;
                                isH = false;
                                break;
                        }

                        List<MasuBango> srcAll = new List<MasuBango>();
                        if (isA) { srcAll.AddRange(KomanoKidou.SrcA_Hisya(sengo, dst1)); }
                        if (isB) { srcAll.AddRange(KomanoKidou.SrcB_Oh(sengo, dst1)); }
                        if (isC) { srcAll.AddRange(KomanoKidou.SrcC_Hisya(sengo, dst1)); }
                        if (isD) { srcAll.AddRange(KomanoKidou.SrcD_Oh(sengo, dst1)); }
                        if (isE) { srcAll.AddRange(KomanoKidou.SrcE_Hisya(sengo, dst1)); }
                        if (isF) { srcAll.AddRange(KomanoKidou.SrcF_Oh(sengo, dst1)); }
                        if (isG) { srcAll.AddRange(KomanoKidou.SrcG_Hisya(sengo, dst1)); }
                        if (isH) { srcAll.AddRange(KomanoKidou.SrcH_Oh(sengo, dst1)); }

                        if (Translator_TextToProcess.Hit(sengo, srcSyurui, srcAll, komas, out found))
                        {
                            srcOkiba = Okiba.SHOGIBAN;
                            goto gt_EndSyurui;
                        }
                    }
                    break;
                #endregion

                #region 馬
                //************************************************************
                // 馬
                //************************************************************
                case KomaSyurui.UMA:
                    {
                        //----------
                        // 候補マス
                        //----------
                        //  ┌─┬─┬─┬─┬─┬─┬─┬─┬─┬─┬─┬─┬─┬─┬─┬─┬─┐
                        //  │H7│  │  │  │  │  │  │  │  │  │  │  │  │  │  │  │B7│
                        //  ├─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┤
                        //  │  │H6│  │  │  │  │  │  │  │  │  │  │  │  │  │B6│  │
                        //  ├─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┤
                        //  │  │  │H5│  │  │  │  │  │  │  │  │  │  │  │B5│  │  │
                        //  ├─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┤
                        //  │  │  │  │H4│  │  │  │  │  │  │  │  │  │B4│  │  │  │
                        //  ├─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┤
                        //　│  │  │  │  │H3│  │  │  │  │  │  │  │B3│  │  │  │  │
                        //  ├─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┤
                        //  │  │  │  │  │  │H2│  │  │  │  │  │B2│  │  │  │  │  │
                        //  ├─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┤
                        //  │  │  │  │  │  │  │H1│  │  │  │B1│  │  │  │  │  │  │
                        //  ├─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┤
                        //  │  │  │  │  │  │  │  │H0│Ａ│B0│  │  │  │  │  │  │  │
                        //  ├─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┤
                        //  │  │  │  │  │  │  │  │Ｇ│至│Ｃ│  │  │  │  │  │  │  │
                        //  ├─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┤
                        //  │  │  │  │  │  │  │  │F0│Ｅ│D0│  │  │  │  │  │  │  │
                        //  ├─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┤
                        //  │  │  │  │  │  │  │F1│  │  │  │D1│  │  │  │  │  │  │
                        //  ├─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┤
                        //  │  │  │  │  │  │F2│  │  │  │  │  │D2│  │  │  │  │  │
                        //  ├─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┤
                        //  │  │  │  │  │F3│  │  │  │  │  │  │  │D3│  │  │  │  │
                        //  ├─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┤
                        //　│  │  │  │F4│  │  │  │  │  │  │  │  │  │D4│  │  │  │
                        //  ├─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┤
                        //  │  │  │F5│  │  │  │  │  │  │  │  │  │  │  │D5│  │  │
                        //  ├─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┤
                        //  │  │F6│  │  │  │  │  │  │  │  │  │  │  │  │  │D6│  │
                        //  ├─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┼─┤
                        //  │F7│  │  │  │  │  │  │  │  │  │  │  │  │  │  │  │D7│
                        //  └─┴─┴─┴─┴─┴─┴─┴─┴─┴─┴─┴─┴─┴─┴─┴─┴─┘
                        bool isA = true;
                        bool isB = true;
                        bool isC = true;
                        bool isD = true;
                        bool isE = true;
                        bool isF = true;
                        bool isG = true;
                        bool isH = true;

                        switch (agaruHiku)
                        {
                            case AgaruHiku.Yoru:
                                isA = false;
                                isB = false;
                                isD = false;
                                isE = false;
                                isF = false;
                                isH = false;
                                break;
                            case AgaruHiku.Agaru:
                                isA = false;
                                isB = false;
                                isC = false;
                                isG = false;
                                isH = false;
                                break;
                            case AgaruHiku.Hiku:
                                isC = false;
                                isD = false;
                                isE = false;
                                isF = false;
                                isG = false;
                                break;
                        }

                        switch (migiHidari)
                        {
                            case MigiHidari.Migi:
                                isA = false;
                                isE = false;
                                isF = false;
                                isG = false;
                                isH = false;
                                break;
                            case MigiHidari.Hidari:
                                isA = false;
                                isB = false;
                                isC = false;
                                isD = false;
                                isE = false;
                                break;
                            case MigiHidari.Sugu:
                                isA = false;
                                isB = false;
                                isC = false;
                                isD = false;
                                isF = false;
                                isG = false;
                                isH = false;
                                break;
                        }

                        List<MasuBango> srcAll = new List<MasuBango>();
                        if (isA) { srcAll.AddRange(KomanoKidou.SrcA_Oh(sengo, dst1)); }
                        if (isB) { srcAll.AddRange(KomanoKidou.SrcB_Kaku(sengo, dst1)); }
                        if (isC) { srcAll.AddRange(KomanoKidou.SrcC_Oh(sengo, dst1)); }
                        if (isD) { srcAll.AddRange(KomanoKidou.SrcD_Kaku(sengo, dst1)); }
                        if (isE) { srcAll.AddRange(KomanoKidou.SrcE_Oh(sengo, dst1)); }
                        if (isF) { srcAll.AddRange(KomanoKidou.SrcF_Kaku(sengo, dst1)); }
                        if (isG) { srcAll.AddRange(KomanoKidou.SrcG_Oh(sengo, dst1)); }
                        if (isH) { srcAll.AddRange(KomanoKidou.SrcH_Kaku(sengo, dst1)); }

                        if (Translator_TextToProcess.Hit(sengo, srcSyurui, srcAll, komas, out found))
                        {
                            srcOkiba = Okiba.SHOGIBAN;
                            goto gt_EndSyurui;
                        }
                    }
                    break;
                #endregion

                #region エラー
                //************************************************************
                // エラー
                //************************************************************
                default:
                    {
                    }
                    break;
                #endregion

            }

        gt_EndShogiban:

            if (null == found && utsu)
            {
                // 駒台の駒を打ちます。
                //>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>

                List<Button_Koma> btnKomas = komas.FindKomaByOkibaSengoSyurui(srcOkiba, sengo, srcSyurui);

                if (0 < btnKomas.Count)
                {
                    switch (sengo)
                    {
                        case Sengo.GOTE:
                            srcOkiba = Okiba.GOTE_KOMADAI;
                            break;
                        case Sengo.SENTE:
                            srcOkiba = Okiba.SENTE_KOMADAI;
                            break;
                        default:
                            srcOkiba = Okiba.ERROR;
                            break;
                    }

                    found = btnKomas[0];
                    goto gt_EndSyurui;
                }
            }

        gt_EndSyurui:


            int srcSuji;
            int srcDan;
            if (null != found)
            {
                // 将棋盤の上に駒がありました。
                //>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>

                srcSuji = found.Masu.Suji;
                srcDan = found.Masu.Dan;
            }
            else
            {
                // 「打」のとき。
                //>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>

                srcSuji = MasuBango.DA_SUJI;
                srcDan = MasuBango.DA_DAN;
            }


            KomaSyurui syurui;
            if (NariFunari.Nari == nariFunari)
            {
                // 成ります
                syurui = Converter.SyuruiToNariCase(srcSyurui);
            }
            else
            {
                // そのままです。
                syurui = srcSyurui;
            }

            process = new MasuBango(
                sengo,
                Okiba.SHOGIBAN, //符号は将棋盤の升目です。
                srcOkiba,
                suji,
                dan,
                srcSuji,
                srcDan,
                syurui,
                srcSyurui
            );


        }

    }
}
