﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

using System.Text.RegularExpressions;

namespace Xenon.KifuNarabe
{


    /// <summary>
    /// 「▲７六歩△３四歩▲６六歩」形式の棋譜。
    /// </summary>
    public class Kifu1View
    {


        #region プロパティー類
        //------------------------------------------------------------
        private Kifu kifu;

        public Kifu Kifu
        {
            get
            {
                return this.kifu;
            }
        }
        //------------------------------------------------------------
        #endregion


        /// <summary>
        /// 
        /// </summary>
        public Kifu1View()
        {
            this.kifu = new Kifu();
        }


        /// <summary>
        /// 
        /// </summary>
        /// <param name="kifu">現在の局面までの棋譜。</param>
        public Kifu1View(Kifu kifu)
        {
            this.kifu = kifu.Clone();
        }


        ///// <summary>
        ///// コピーして返します。
        ///// </summary>
        ///// <returns></returns>
        //public List<Fugo> ToFugoList()
        //{
        //    List<Fugo> list = new List<Fugo>();

        //    foreach (Fugo f in this.Kifu.FugoList)
        //    {
        //        list.Add(f);
        //    }

        //    return list;
        //}





        /// <summary>
        /// 符号リスト。「▲２六歩△８四歩▲７六歩」…。
        /// </summary>
        /// <param name="fugoList"></param>
        public string ToText(KomaCollection komas, Kifu kifu)
        {
            StringBuilder sb = new StringBuilder();

            MasuBango previousMasu = null;
            foreach (MasuBango masu in this.Kifu.MasuBangoList)
            {
                View_Fugo fugo = Translator_MasuToFugo1.TranslateMasuToFugo1(masu, komas, kifu);

                sb.Append(fugo.ToString(true, masu, previousMasu));

                previousMasu = masu;
            }

            //System.Console.WriteLine("size(" + fugoList.Count+")"+sb.ToString());

            return sb.ToString();
        }

    }


}
