﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Xenon.KifuNarabe
{

    /// <summary>
    /// ゲームの状態
    /// </summary>
    public class GameState
    {

        //------------------------------------------------------------
        private Sengo sengo;

        /// <summary>
        /// 現在の先後
        /// </summary>
        public Sengo Sengo
        {
            get
            {
                return this.sengo;
            }
        }

        private int ittemaeSuji;

        /// <summary>
        /// 一手前の筋
        /// </summary>
        public int IttemaeSuji
        {
            get
            {
                return this.ittemaeSuji;
            }
        }

        private int ittemaeDan;

        /// <summary>
        /// 一手前の段
        /// </summary>
        public int IttemaeDan
        {
            get
            {
                return this.ittemaeDan;
            }
        }
        //------------------------------------------------------------

        public GameState()
        {
            this.Init();
        }

        public void Init()
        {
            this.ittemaeSuji = MasuBango.INITIALIZED_SUJI;
            this.ittemaeDan = MasuBango.INITIALIZED_DAN;
            this.sengo = Sengo.SENTE;
        }

        public void ChangeTurn( int lastSuji, int lastDan, Uc_Main uc_Main)
        {
            this.ittemaeSuji = lastSuji;
            this.ittemaeDan = lastDan;
            System.Console.WriteLine("一手前筋：" + this.ittemaeSuji + "　一手前段：" + this.ittemaeDan);

            this.sengo = Actions_GameState.AlternateSengo(this.sengo);

            uc_Main.LblSengo.Text = Converter.SengoToKanji(uc_Main.GameState.Sengo);
        }
    }
}
