﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

using System.Text.RegularExpressions;

namespace Xenon.KifuNarabe
{

    [Serializable]
    public partial class Uc_Main : UserControl
    {

        #region プロパティー類

        //------------------------------------------------------------
        /// <summary>
        /// ゲームの状態
        /// </summary>
        public GameState GameState
        {
            get;
            set;
        }
        //------------------------------------------------------------
        private Kifu kifu;

        /// <summary>
        /// 棋譜
        /// </summary>
        public Kifu Kifu
        {
            get
            {
                return this.kifu;
            }
        }
        //------------------------------------------------------------
        /// <summary>
        /// 将棋盤
        /// </summary>
        public Shogiban Shogiban
        {
            get;
            set;
        }
        //------------------------------------------------------------
        /// <summary>
        /// 駒置き。[0]先手、[1]後手。
        /// </summary>
        public Komadai[] KomadaiArr
        {
            get;
            set;
        }
        //------------------------------------------------------------
        public void SetInputText(String text)
        {
            this.txtInput1.Text = text;
        }
        //------------------------------------------------------------
        public void AppendInputText(String text)
        {
            this.txtInput1.Text += text;
        }
        //------------------------------------------------------------
        /// <summary>
        /// 棋譜を出力します。
        /// </summary>
        /// <param name="text"></param>
        public void OutputKifu()
        {
            this.txtOutput1.Text = new Kifu1View(this.kifu).ToText(this.KomaCollection,this.kifu);
            this.txtOutput2.Text = new Kifu2View(this.kifu).ToText();
        }
        //------------------------------------------------------------
        public KomaCollection KomaCollection
        {
            get;
            set;
        }
        //------------------------------------------------------------
        private Label2 lblSengo;
        /// <summary>
        /// 先後表示
        /// </summary>
        public Label2 LblSengo
        {
            get
            {
                return this.lblSengo;
            }
        }
        //------------------------------------------------------------
        private Label2 lblFugo;
        /// <summary>
        /// 符号表示
        /// </summary>
        public Label2 LblFugo
        {
            get
            {
                return this.lblFugo;
            }
        }
        //------------------------------------------------------------
        private Button2 btnNaru;
        /// <summary>
        /// 成るボタン
        /// </summary>
        public Button2 BtnNaru
        {
            get
            {
                return this.btnNaru;
            }
        }
        //------------------------------------------------------------
        private Button2 btnMuki;
        /// <summary>
        /// 向きボタン
        /// </summary>
        public Button2 BtnMuki
        {
            get
            {
                return this.btnMuki;
            }
        }
        //------------------------------------------------------------
        private Button2 btnSyokihaichi;
        /// <summary>
        /// 初期配置ボタン
        /// </summary>
        public Button2 BtnSyokihaichi
        {
            get
            {
                return this.btnSyokihaichi;
            }
        }
        //------------------------------------------------------------
        private Button2 btnClear;
        /// <summary>
        /// クリアーボタン
        /// </summary>
        public Button2 BtnClear
        {
            get
            {
                return this.btnClear;
            }
        }
        //------------------------------------------------------------
        private Button2 btnHtml;
        /// <summary>
        /// HTMLボタン
        /// </summary>
        public Button2 BtnHtml
        {
            get
            {
                return this.btnHtml;
            }
        }
        //------------------------------------------------------------
        private Button2 btnPlay;
        /// <summary>
        /// 再生ボタン
        /// </summary>
        public Button2 BtnPlay
        {
            get
            {
                return this.btnPlay;
            }
        }
        //------------------------------------------------------------
        private Button2 btnForward;
        /// <summary>
        /// コマ送りボタン
        /// </summary>
        public Button2 BtnForward
        {
            get
            {
                return this.btnForward;
            }
        }
        //------------------------------------------------------------
        private Button2 btnFugo_Sente;
        /// <summary>
        /// [▲]符号ボタン
        /// </summary>
        public Button2 BtnFugo_Sente
        {
            get
            {
                return this.btnFugo_Sente;
            }
        }
        //------------------------------------------------------------
        private Button2 btnFugo_Gote;
        /// <summary>
        /// [△]符号ボタン
        /// </summary>
        public Button2 BtnFugo_Gote
        {
            get
            {
                return this.btnFugo_Gote;
            }
        }
        //------------------------------------------------------------
        private Button2 btnFugo_1;
        /// <summary>
        /// [１]符号ボタン
        /// </summary>
        public Button2 BtnFugo_1
        {
            get
            {
                return this.btnFugo_1;
            }
        }
        //------------------------------------------------------------
        private Button2 btnFugo_2;
        /// <summary>
        /// [２]符号ボタン
        /// </summary>
        public Button2 BtnFugo_2
        {
            get
            {
                return this.btnFugo_2;
            }
        }
        //------------------------------------------------------------
        private Button2 btnFugo_3;
        /// <summary>
        /// [３]符号ボタン
        /// </summary>
        public Button2 BtnFugo_3
        {
            get
            {
                return this.btnFugo_3;
            }
        }
        //------------------------------------------------------------
        private Button2 btnFugo_4;
        /// <summary>
        /// [４]符号ボタン
        /// </summary>
        public Button2 BtnFugo_4
        {
            get
            {
                return this.btnFugo_4;
            }
        }
        //------------------------------------------------------------
        private Button2 btnFugo_5;
        /// <summary>
        /// [５]符号ボタン
        /// </summary>
        public Button2 BtnFugo_5
        {
            get
            {
                return this.btnFugo_5;
            }
        }
        //------------------------------------------------------------
        private Button2 btnFugo_6;
        /// <summary>
        /// [６]符号ボタン
        /// </summary>
        public Button2 BtnFugo_6
        {
            get
            {
                return this.btnFugo_6;
            }
        }
        //------------------------------------------------------------
        private Button2 btnFugo_7;
        /// <summary>
        /// [７]符号ボタン
        /// </summary>
        public Button2 BtnFugo_7
        {
            get
            {
                return this.btnFugo_7;
            }
        }
        //------------------------------------------------------------
        private Button2 btnFugo_8;
        /// <summary>
        /// [８]符号ボタン
        /// </summary>
        public Button2 BtnFugo_8
        {
            get
            {
                return this.btnFugo_8;
            }
        }
        //------------------------------------------------------------
        private Button2 btnFugo_9;
        /// <summary>
        /// [９]符号ボタン
        /// </summary>
        public Button2 BtnFugo_9
        {
            get
            {
                return this.btnFugo_9;
            }
        }
        //------------------------------------------------------------
        private Button2 btnFugo_01;
        /// <summary>
        /// [一]符号ボタン
        /// </summary>
        public Button2 BtnFugo_01
        {
            get
            {
                return this.btnFugo_01;
            }
        }
        //------------------------------------------------------------
        private Button2 btnFugo_02;
        /// <summary>
        /// [二]符号ボタン
        /// </summary>
        public Button2 BtnFugo_02
        {
            get
            {
                return this.btnFugo_02;
            }
        }
        //------------------------------------------------------------
        private Button2 btnFugo_03;
        /// <summary>
        /// [三]符号ボタン
        /// </summary>
        public Button2 BtnFugo_03
        {
            get
            {
                return this.btnFugo_03;
            }
        }
        //------------------------------------------------------------
        private Button2 btnFugo_04;
        /// <summary>
        /// [四]符号ボタン
        /// </summary>
        public Button2 BtnFugo_04
        {
            get
            {
                return this.btnFugo_04;
            }
        }
        //------------------------------------------------------------
        private Button2 btnFugo_05;
        /// <summary>
        /// [五]符号ボタン
        /// </summary>
        public Button2 BtnFugo_05
        {
            get
            {
                return this.btnFugo_05;
            }
        }
        //------------------------------------------------------------
        private Button2 btnFugo_06;
        /// <summary>
        /// [六]符号ボタン
        /// </summary>
        public Button2 BtnFugo_06
        {
            get
            {
                return this.btnFugo_06;
            }
        }
        //------------------------------------------------------------
        private Button2 btnFugo_07;
        /// <summary>
        /// [七]符号ボタン
        /// </summary>
        public Button2 BtnFugo_07
        {
            get
            {
                return this.btnFugo_07;
            }
        }
        //------------------------------------------------------------
        private Button2 btnFugo_08;
        /// <summary>
        /// [八]符号ボタン
        /// </summary>
        public Button2 BtnFugo_08
        {
            get
            {
                return this.btnFugo_08;
            }
        }
        //------------------------------------------------------------
        private Button2 btnFugo_09;
        /// <summary>
        /// [九]符号ボタン
        /// </summary>
        public Button2 BtnFugo_09
        {
            get
            {
                return this.btnFugo_09;
            }
        }
        //------------------------------------------------------------
        private Button2 btnFugo_Dou;
        /// <summary>
        /// [同]符号ボタン
        /// </summary>
        public Button2 BtnFugo_Dou
        {
            get
            {
                return this.btnFugo_Dou;
            }
        }
        //------------------------------------------------------------
        private Button2 btnFugo_Fu;
        /// <summary>
        /// [歩]符号ボタン
        /// </summary>
        public Button2 BtnFugo_Fu
        {
            get
            {
                return this.btnFugo_Fu;
            }
        }
        //------------------------------------------------------------
        private Button2 btnFugo_Hisya;
        /// <summary>
        /// [飛]符号ボタン
        /// </summary>
        public Button2 BtnFugo_Hisya
        {
            get
            {
                return this.btnFugo_Hisya;
            }
        }
        //------------------------------------------------------------
        private Button2 btnFugo_Kaku;
        /// <summary>
        /// [角]符号ボタン
        /// </summary>
        public Button2 BtnFugo_Kaku
        {
            get
            {
                return this.btnFugo_Kaku;
            }
        }
        //------------------------------------------------------------
        private Button2 btnFugo_Kyo;
        /// <summary>
        /// [香]符号ボタン
        /// </summary>
        public Button2 BtnFugo_Kyo
        {
            get
            {
                return this.btnFugo_Kyo;
            }
        }
        //------------------------------------------------------------
        private Button2 btnFugo_Kei;
        /// <summary>
        /// [桂]符号ボタン
        /// </summary>
        public Button2 BtnFugo_Kei
        {
            get
            {
                return this.btnFugo_Kei;
            }
        }
        //------------------------------------------------------------
        private Button2 btnFugo_Gin;
        /// <summary>
        /// [銀]符号ボタン
        /// </summary>
        public Button2 BtnFugo_Gin
        {
            get
            {
                return this.btnFugo_Gin;
            }
        }
        //------------------------------------------------------------
        private Button2 btnFugo_Kin;
        /// <summary>
        /// [金]符号ボタン
        /// </summary>
        public Button2 BtnFugo_Kin
        {
            get
            {
                return this.btnFugo_Kin;
            }
        }
        //------------------------------------------------------------
        private Button2 btnFugo_Oh;
        /// <summary>
        /// [王]符号ボタン
        /// </summary>
        public Button2 BtnFugo_Oh
        {
            get
            {
                return this.btnFugo_Oh;
            }
        }
        //------------------------------------------------------------
        private Button2 btnFugo_Gyoku;
        /// <summary>
        /// [玉]符号ボタン
        /// </summary>
        public Button2 BtnFugo_Gyoku
        {
            get
            {
                return this.btnFugo_Gyoku;
            }
        }
        //------------------------------------------------------------
        private Button2 btnFugo_Tokin;
        /// <summary>
        /// [と]符号ボタン
        /// </summary>
        public Button2 BtnFugo_Tokin
        {
            get
            {
                return this.btnFugo_Tokin;
            }
        }
        //------------------------------------------------------------
        private Button2 btnFugo_Narikyo;
        /// <summary>
        /// [成香]符号ボタン
        /// </summary>
        public Button2 BtnFugo_Narikyo
        {
            get
            {
                return this.btnFugo_Narikyo;
            }
        }
        //------------------------------------------------------------
        private Button2 btnFugo_Narikei;
        /// <summary>
        /// [成桂]符号ボタン
        /// </summary>
        public Button2 BtnFugo_Narikei
        {
            get
            {
                return this.btnFugo_Narikei;
            }
        }
        //------------------------------------------------------------
        private Button2 btnFugo_Narigin;
        /// <summary>
        /// [成銀]符号ボタン
        /// </summary>
        public Button2 BtnFugo_Narigin
        {
            get
            {
                return this.btnFugo_Narigin;
            }
        }
        //------------------------------------------------------------
        private Button2 btnFugo_Ryu;
        /// <summary>
        /// [竜]符号ボタン
        /// </summary>
        public Button2 BtnFugo_Ryu
        {
            get
            {
                return this.btnFugo_Ryu;
            }
        }
        //------------------------------------------------------------
        private Button2 btnFugo_Uma;
        /// <summary>
        /// [馬]符号ボタン
        /// </summary>
        public Button2 BtnFugo_Uma
        {
            get
            {
                return this.btnFugo_Uma;
            }
        }
        //------------------------------------------------------------
        private Button2 btnFugo_Yoru;
        /// <summary>
        /// [寄]符号ボタン
        /// </summary>
        public Button2 BtnFugo_Yoru
        {
            get
            {
                return this.btnFugo_Yoru;
            }
        }
        //------------------------------------------------------------
        private Button2 btnFugo_Hiku;
        /// <summary>
        /// [引]符号ボタン
        /// </summary>
        public Button2 BtnFugo_Hiku
        {
            get
            {
                return this.btnFugo_Hiku;
            }
        }
        //------------------------------------------------------------
        private Button2 btnFugo_Agaru;
        /// <summary>
        /// [上]符号ボタン
        /// </summary>
        public Button2 BtnFugo_Agaru
        {
            get
            {
                return this.btnFugo_Agaru;
            }
        }
        //------------------------------------------------------------
        private Button2 btnFugo_Migi;
        /// <summary>
        /// [右]符号ボタン
        /// </summary>
        public Button2 BtnFugo_Migi
        {
            get
            {
                return this.btnFugo_Migi;
            }
        }
        //------------------------------------------------------------
        private Button2 btnFugo_Hidari;
        /// <summary>
        /// [左]符号ボタン
        /// </summary>
        public Button2 BtnFugo_Hidari
        {
            get
            {
                return this.btnFugo_Hidari;
            }
        }
        //------------------------------------------------------------
        private Button2 btnFugo_Sugu;
        /// <summary>
        /// [直]符号ボタン
        /// </summary>
        public Button2 BtnFugo_Sugu
        {
            get
            {
                return this.btnFugo_Sugu;
            }
        }
        //------------------------------------------------------------
        private Button2 btnFugo_Nari;
        /// <summary>
        /// [成]符号ボタン
        /// </summary>
        public Button2 BtnFugo_Nari
        {
            get
            {
                return this.btnFugo_Nari;
            }
        }
        //------------------------------------------------------------
        private Button2 btnFugo_Funari;
        /// <summary>
        /// [不成]符号ボタン
        /// </summary>
        public Button2 BtnFugo_Funari
        {
            get
            {
                return this.btnFugo_Funari;
            }
        }
        //------------------------------------------------------------
        private Button2 btnFugo_Da;
        /// <summary>
        /// [打]符号ボタン
        /// </summary>
        public Button2 BtnFugo_Da
        {
            get
            {
                return this.btnFugo_Da;
            }
        }
        //------------------------------------------------------------
        private Button2 btnFugo_Zenkesi;
        /// <summary>
        /// [全消]ボタン     ＜入力欄用＞
        /// </summary>
        public Button2 BtnFugo_Zenkesi
        {
            get
            {
                return this.btnFugo_Zenkesi;
            }
        }
        //------------------------------------------------------------
        #endregion




        public Uc_Main()
        {
            this.kifu = new Kifu();

            this.KomaCollection = new KomaCollection();

            InitializeComponent();

            //----------
            // ゲームの状態
            //----------
            this.GameState = new GameState();

            //----------
            // 将棋盤
            //----------
            this.Shogiban = new Shogiban(200, 220);

            //----------
            // 駒置き
            //----------
            this.KomadaiArr = new Komadai[2];
            this.KomadaiArr[0] = new Komadai(Okiba.SENTE_KOMADAI, 610, 220, Sengo.SENTE);
            this.KomadaiArr[1] = new Komadai(Okiba.GOTE_KOMADAI,  10, 170, Sengo.GOTE);

            //----------
            // 駒
            //----------

            Okiba okiba = Okiba.SHOGIBAN;
            // 先手
            this.KomaCollection.Kyokumen.Items.Add(new Button_Koma(okiba, KomaSyurui.FU, 1, 7, this.Shogiban.SujiToX(1), this.Shogiban.DanToY(7), Sengo.SENTE));
            this.KomaCollection.Kyokumen.Items.Add(new Button_Koma(okiba, KomaSyurui.FU, 2, 7, this.Shogiban.SujiToX(2), this.Shogiban.DanToY(7), Sengo.SENTE));
            this.KomaCollection.Kyokumen.Items.Add(new Button_Koma(okiba, KomaSyurui.FU, 3, 7, this.Shogiban.SujiToX(3), this.Shogiban.DanToY(7), Sengo.SENTE));
            this.KomaCollection.Kyokumen.Items.Add(new Button_Koma(okiba, KomaSyurui.FU, 4, 7, this.Shogiban.SujiToX(4), this.Shogiban.DanToY(7), Sengo.SENTE));
            this.KomaCollection.Kyokumen.Items.Add(new Button_Koma(okiba, KomaSyurui.FU, 5, 7, this.Shogiban.SujiToX(5), this.Shogiban.DanToY(7), Sengo.SENTE));
            this.KomaCollection.Kyokumen.Items.Add(new Button_Koma(okiba, KomaSyurui.FU, 6, 7, this.Shogiban.SujiToX(6), this.Shogiban.DanToY(7), Sengo.SENTE));
            this.KomaCollection.Kyokumen.Items.Add(new Button_Koma(okiba, KomaSyurui.FU, 7, 7, this.Shogiban.SujiToX(7), this.Shogiban.DanToY(7), Sengo.SENTE));
            this.KomaCollection.Kyokumen.Items.Add(new Button_Koma(okiba, KomaSyurui.FU, 8, 7, this.Shogiban.SujiToX(8), this.Shogiban.DanToY(7), Sengo.SENTE));
            this.KomaCollection.Kyokumen.Items.Add(new Button_Koma(okiba, KomaSyurui.FU, 9, 7, this.Shogiban.SujiToX(9), this.Shogiban.DanToY(7), Sengo.SENTE));
            this.KomaCollection.Kyokumen.Items.Add(new Button_Koma(okiba, KomaSyurui.HISYA, 2, 8, this.Shogiban.SujiToX(2), this.Shogiban.DanToY(8), Sengo.SENTE));
            this.KomaCollection.Kyokumen.Items.Add(new Button_Koma(okiba, KomaSyurui.KAKU, 8, 8, this.Shogiban.SujiToX(8), this.Shogiban.DanToY(8), Sengo.SENTE));
            this.KomaCollection.Kyokumen.Items.Add(new Button_Koma(okiba, KomaSyurui.KYO, 1, 9, this.Shogiban.SujiToX(1), this.Shogiban.DanToY(9), Sengo.SENTE));
            this.KomaCollection.Kyokumen.Items.Add(new Button_Koma(okiba, KomaSyurui.KEI, 2, 9, this.Shogiban.SujiToX(2), this.Shogiban.DanToY(9), Sengo.SENTE));
            this.KomaCollection.Kyokumen.Items.Add(new Button_Koma(okiba, KomaSyurui.GIN, 3, 9, this.Shogiban.SujiToX(3), this.Shogiban.DanToY(9), Sengo.SENTE));
            this.KomaCollection.Kyokumen.Items.Add(new Button_Koma(okiba, KomaSyurui.KIN, 4, 9, this.Shogiban.SujiToX(4), this.Shogiban.DanToY(9), Sengo.SENTE));
            this.KomaCollection.Kyokumen.Items.Add(new Button_Koma(okiba, KomaSyurui.OH, 5, 9, this.Shogiban.SujiToX(5), this.Shogiban.DanToY(9), Sengo.SENTE));
            this.KomaCollection.Kyokumen.Items.Add(new Button_Koma(okiba, KomaSyurui.KIN, 6, 9, this.Shogiban.SujiToX(6), this.Shogiban.DanToY(9), Sengo.SENTE));
            this.KomaCollection.Kyokumen.Items.Add(new Button_Koma(okiba, KomaSyurui.GIN, 7, 9, this.Shogiban.SujiToX(7), this.Shogiban.DanToY(9), Sengo.SENTE));
            this.KomaCollection.Kyokumen.Items.Add(new Button_Koma(okiba, KomaSyurui.KEI, 8, 9, this.Shogiban.SujiToX(8), this.Shogiban.DanToY(9), Sengo.SENTE));
            this.KomaCollection.Kyokumen.Items.Add(new Button_Koma(okiba, KomaSyurui.KYO, 9, 9, this.Shogiban.SujiToX(9), this.Shogiban.DanToY(9), Sengo.SENTE));

            // 後手
            this.KomaCollection.Kyokumen.Items.Add(new Button_Koma(okiba, KomaSyurui.FU, 1, 3, this.Shogiban.SujiToX(1), this.Shogiban.DanToY(3), Sengo.GOTE));
            this.KomaCollection.Kyokumen.Items.Add(new Button_Koma(okiba, KomaSyurui.FU, 2, 3, this.Shogiban.SujiToX(2), this.Shogiban.DanToY(3), Sengo.GOTE));
            this.KomaCollection.Kyokumen.Items.Add(new Button_Koma(okiba, KomaSyurui.FU, 3, 3, this.Shogiban.SujiToX(3), this.Shogiban.DanToY(3), Sengo.GOTE));
            this.KomaCollection.Kyokumen.Items.Add(new Button_Koma(okiba, KomaSyurui.FU, 4, 3, this.Shogiban.SujiToX(4), this.Shogiban.DanToY(3), Sengo.GOTE));
            this.KomaCollection.Kyokumen.Items.Add(new Button_Koma(okiba, KomaSyurui.FU, 5, 3, this.Shogiban.SujiToX(5), this.Shogiban.DanToY(3), Sengo.GOTE));
            this.KomaCollection.Kyokumen.Items.Add(new Button_Koma(okiba, KomaSyurui.FU, 6, 3, this.Shogiban.SujiToX(6), this.Shogiban.DanToY(3), Sengo.GOTE));
            this.KomaCollection.Kyokumen.Items.Add(new Button_Koma(okiba, KomaSyurui.FU, 7, 3, this.Shogiban.SujiToX(7), this.Shogiban.DanToY(3), Sengo.GOTE));
            this.KomaCollection.Kyokumen.Items.Add(new Button_Koma(okiba, KomaSyurui.FU, 8, 3, this.Shogiban.SujiToX(8), this.Shogiban.DanToY(3), Sengo.GOTE));
            this.KomaCollection.Kyokumen.Items.Add(new Button_Koma(okiba, KomaSyurui.FU, 9, 3, this.Shogiban.SujiToX(9), this.Shogiban.DanToY(3), Sengo.GOTE));
            this.KomaCollection.Kyokumen.Items.Add(new Button_Koma(okiba, KomaSyurui.HISYA, 8, 2, this.Shogiban.SujiToX(8), this.Shogiban.DanToY(2), Sengo.GOTE));
            this.KomaCollection.Kyokumen.Items.Add(new Button_Koma(okiba, KomaSyurui.KAKU, 2, 2, this.Shogiban.SujiToX(2), this.Shogiban.DanToY(2), Sengo.GOTE));
            this.KomaCollection.Kyokumen.Items.Add(new Button_Koma(okiba, KomaSyurui.KYO, 1, 1, this.Shogiban.SujiToX(1), this.Shogiban.DanToY(1), Sengo.GOTE));
            this.KomaCollection.Kyokumen.Items.Add(new Button_Koma(okiba, KomaSyurui.KEI, 2, 1, this.Shogiban.SujiToX(2), this.Shogiban.DanToY(1), Sengo.GOTE));
            this.KomaCollection.Kyokumen.Items.Add(new Button_Koma(okiba, KomaSyurui.GIN, 3, 1, this.Shogiban.SujiToX(3), this.Shogiban.DanToY(1), Sengo.GOTE));
            this.KomaCollection.Kyokumen.Items.Add(new Button_Koma(okiba, KomaSyurui.KIN, 4, 1, this.Shogiban.SujiToX(4), this.Shogiban.DanToY(1), Sengo.GOTE));
            this.KomaCollection.Kyokumen.Items.Add(new Button_Koma(okiba, KomaSyurui.OH, 5, 1, this.Shogiban.SujiToX(5), this.Shogiban.DanToY(1), Sengo.GOTE));
            this.KomaCollection.Kyokumen.Items.Add(new Button_Koma(okiba, KomaSyurui.KIN, 6, 1, this.Shogiban.SujiToX(6), this.Shogiban.DanToY(1), Sengo.GOTE));
            this.KomaCollection.Kyokumen.Items.Add(new Button_Koma(okiba, KomaSyurui.GIN, 7, 1, this.Shogiban.SujiToX(7), this.Shogiban.DanToY(1), Sengo.GOTE));
            this.KomaCollection.Kyokumen.Items.Add(new Button_Koma(okiba, KomaSyurui.KEI, 8, 1, this.Shogiban.SujiToX(8), this.Shogiban.DanToY(1), Sengo.GOTE));
            this.KomaCollection.Kyokumen.Items.Add(new Button_Koma(okiba, KomaSyurui.KYO, 9, 1, this.Shogiban.SujiToX(9), this.Shogiban.DanToY(1), Sengo.GOTE));

            //----------
            // 成るボタン
            //----------
            this.btnNaru = new Button2("成る", 250, 590);

            //----------
            // 向きボタン
            //----------
            this.btnMuki = new Button2("向き", 330, 590);

            //----------
            // 初期配置ボタン
            //----------
            this.btnSyokihaichi = new Button2("初期配置", 450, 590);

            //----------
            // クリアーボタン
            //----------
            this.btnClear = new Button2("クリアー", 450, 630);

            //----------
            // HTMLボタン
            //----------
            this.btnHtml = new Button2("HTML", 570, 630);

            //----------
            // 再生ボタン
            //----------
            this.btnPlay = new Button2("再生", 710, 0);

            //----------
            // コマ送りボタン
            //----------
            this.btnForward = new Button2("コマ送り", 710, 40);

            //----------
            // [▲]～[打]符号ボタン
            //----------
            int ox = 30;
            int oy = 70;
            int w = 23;
            int h = 23;
            float fontSize = 13.0f;
            this.btnFugo_Sente = new Button2("▲", ox, 0 * h + oy, w, h, fontSize);
            this.btnFugo_Gote = new Button2("△", ox, 1 * h + oy, w, h, fontSize);
            ox += w;

            this.btnFugo_1 = new Button2("１", 0 * w + ox, 0 * h + oy, w, h, fontSize);
            this.btnFugo_2 = new Button2("２", 1 * w + ox, 0 * h + oy, w, h, fontSize);
            this.btnFugo_3 = new Button2("３", 2 * w + ox, 0 * h + oy, w, h, fontSize);
            this.btnFugo_4 = new Button2("４", 0 * w + ox, 1 * h + oy, w, h, fontSize);
            this.btnFugo_5 = new Button2("５", 1 * w + ox, 1 * h + oy, w, h, fontSize);
            this.btnFugo_6 = new Button2("６", 2 * w + ox, 1 * h + oy, w, h, fontSize);
            this.btnFugo_7 = new Button2("７", 0 * w + ox, 2 * h + oy, w, h, fontSize);
            this.btnFugo_8 = new Button2("８", 1 * w + ox, 2 * h + oy, w, h, fontSize);
            this.btnFugo_9 = new Button2("９", 2 * w + ox, 2 * h + oy, w, h, fontSize);
            ox += (3 + 1) * w;

            this.btnFugo_01 = new Button2("一", 0 * w + ox, 0 * h + oy, w, h, fontSize);
            this.btnFugo_02 = new Button2("二", 1 * w + ox, 0 * h + oy, w, h, fontSize);
            this.btnFugo_03 = new Button2("三", 2 * w + ox, 0 * h + oy, w, h, fontSize);
            this.btnFugo_04 = new Button2("四", 0 * w + ox, 1 * h + oy, w, h, fontSize);
            this.btnFugo_05 = new Button2("五", 1 * w + ox, 1 * h + oy, w, h, fontSize);
            this.btnFugo_06 = new Button2("六", 2 * w + ox, 1 * h + oy, w, h, fontSize);
            this.btnFugo_07 = new Button2("七", 0 * w + ox, 2 * h + oy, w, h, fontSize);
            this.btnFugo_08 = new Button2("八", 1 * w + ox, 2 * h + oy, w, h, fontSize);
            this.btnFugo_09 = new Button2("九", 2 * w + ox, 2 * h + oy, w, h, fontSize);
            ox += (3 + 1) * w;

            this.btnFugo_Dou = new Button2("同", 0 * w + ox, 0 * h + oy, w, h, fontSize);
            this.btnFugo_Fu = new Button2("歩", 1 * w + ox, 0 * h + oy, w, h, fontSize);
            this.btnFugo_Hisya = new Button2("飛", 2 * w + ox, 0 * h + oy, w, h, fontSize);
            this.btnFugo_Kaku = new Button2("角", 3 * w + ox, 0 * h + oy, w, h, fontSize);
            this.btnFugo_Kyo = new Button2("香", 4 * w + ox, 0 * h + oy, w, h, fontSize);
            this.btnFugo_Kei = new Button2("桂", 5 * w + ox, 0 * h + oy, w, h, fontSize);
            this.btnFugo_Gin = new Button2("銀", 6 * w + ox, 0 * h + oy, w, h, fontSize);

            this.btnFugo_Kin = new Button2("金", 0 * w + ox, 1 * h + oy, w, h, fontSize);
            this.btnFugo_Oh = new Button2("王", 1 * w + ox, 1 * h + oy, w, h, fontSize);
            this.btnFugo_Gyoku = new Button2("玉", 2 * w + ox, 1 * h + oy, w, h, fontSize);
            this.btnFugo_Tokin = new Button2("と", 3 * w + ox, 1 * h + oy, w, h, fontSize);
            this.btnFugo_Narikyo = new Button2("成香", 4 * w + ox, 1 * h + oy, 2 * w, h, fontSize);

            this.btnFugo_Narikei = new Button2("成桂", 0 * w + ox, 2 * h + oy, 2 * w, h, fontSize);
            this.btnFugo_Narigin = new Button2("成銀", 2 * w + ox, 2 * h + oy, 2 * w, h, fontSize);
            this.btnFugo_Ryu = new Button2("竜", 4 * w + ox, 2 * h + oy, w, h, fontSize);
            this.btnFugo_Uma = new Button2("馬", 5 * w + ox, 2 * h + oy, w, h, fontSize);
            ox += (7 + 1) * w;

            this.btnFugo_Yoru = new Button2("寄", 0 * w + ox, 0 * h + oy, w, h, fontSize);
            this.btnFugo_Hiku = new Button2("引", 1 * w + ox, 0 * h + oy, w, h, fontSize);
            this.btnFugo_Agaru = new Button2("上", 2 * w + ox, 0 * h + oy, w, h, fontSize);

            this.btnFugo_Migi = new Button2("右", 0 * w + ox, 1 * h + oy, w, h, fontSize);
            this.btnFugo_Hidari = new Button2("左", 1 * w + ox, 1 * h + oy, w, h, fontSize);
            this.btnFugo_Sugu = new Button2("直", 2 * w + ox, 1 * h + oy, w, h, fontSize);

            this.btnFugo_Nari = new Button2("成", 0 * w + ox, 2 * h + oy, w, h, fontSize);
            this.btnFugo_Funari = new Button2("不成", 1 * w + ox, 2 * h + oy, 2 * w, h, fontSize);
            this.btnFugo_Da = new Button2("打", 3 * w + ox, 2 * h + oy, w, h, fontSize);
            this.btnFugo_Zenkesi = new Button2("全消", 5 * w + ox, 0 * h + oy, w, h, fontSize);

            //----------
            // 先後表示
            //----------
            this.lblSengo = new Label2("－－", 350, 145);

            //----------
            // 符号表示
            //----------
            this.lblFugo = new Label2("符号", 500, 145);
        }

        public string GetInputText()
        {
            return this.txtInput1.Text;
        }


        private void Uc_Main_Paint(object sender, PaintEventArgs e)
        {
            //----------
            // 将棋盤
            //----------
            this.Shogiban.Paint(e.Graphics);

            //----------
            // 駒置き
            //----------
            foreach(Komadai k in this.KomadaiArr)
            {
                k.Paint(e.Graphics);
            }

            //----------
            // 駒
            //----------
            foreach (Button_Koma koma in this.KomaCollection.Kyokumen.Items)
            {
                koma.Paint(e.Graphics);
            }

            //----------
            // 成るボタン
            //----------
            this.BtnNaru.Paint(e.Graphics);

            //----------
            // 向きボタン
            //----------
            this.BtnMuki.Paint(e.Graphics);

            //----------
            // 初期配置ボタン
            //----------
            this.BtnSyokihaichi.Paint(e.Graphics);

            //----------
            // クリアーボタン
            //----------
            this.BtnClear.Paint(e.Graphics);

            //----------
            // HTMLボタン
            //----------
            this.BtnHtml.Paint(e.Graphics);

            //----------
            // 再生ボタン
            //----------
            this.BtnPlay.Paint(e.Graphics);

            //----------
            // コマ送りボタン
            //----------
            this.BtnForward.Paint(e.Graphics);

            //----------
            // [▲]～[打]符号ボタン
            //----------
            this.BtnFugo_Sente.Paint(e.Graphics);
            this.BtnFugo_Gote.Paint(e.Graphics);
            this.BtnFugo_1.Paint(e.Graphics);
            this.BtnFugo_2.Paint(e.Graphics);
            this.BtnFugo_3.Paint(e.Graphics);
            this.BtnFugo_4.Paint(e.Graphics);
            this.BtnFugo_5.Paint(e.Graphics);
            this.BtnFugo_6.Paint(e.Graphics);
            this.BtnFugo_7.Paint(e.Graphics);
            this.BtnFugo_8.Paint(e.Graphics);
            this.BtnFugo_9.Paint(e.Graphics);
            this.BtnFugo_01.Paint(e.Graphics);
            this.BtnFugo_02.Paint(e.Graphics);
            this.BtnFugo_03.Paint(e.Graphics);
            this.BtnFugo_04.Paint(e.Graphics);
            this.BtnFugo_05.Paint(e.Graphics);
            this.BtnFugo_06.Paint(e.Graphics);
            this.BtnFugo_07.Paint(e.Graphics);
            this.BtnFugo_08.Paint(e.Graphics);
            this.BtnFugo_09.Paint(e.Graphics);
            this.BtnFugo_Dou.Paint(e.Graphics);
            this.BtnFugo_Fu.Paint(e.Graphics);
            this.BtnFugo_Hisya.Paint(e.Graphics);
            this.BtnFugo_Kaku.Paint(e.Graphics);
            this.BtnFugo_Kyo.Paint(e.Graphics);
            this.BtnFugo_Kei.Paint(e.Graphics);
            this.BtnFugo_Gin.Paint(e.Graphics);
            this.BtnFugo_Kin.Paint(e.Graphics);
            this.BtnFugo_Oh.Paint(e.Graphics);
            this.BtnFugo_Gyoku.Paint(e.Graphics);
            this.BtnFugo_Tokin.Paint(e.Graphics);
            this.BtnFugo_Narikyo.Paint(e.Graphics);
            this.BtnFugo_Narikei.Paint(e.Graphics);
            this.BtnFugo_Narigin.Paint(e.Graphics);
            this.BtnFugo_Ryu.Paint(e.Graphics);
            this.BtnFugo_Uma.Paint(e.Graphics);
            this.BtnFugo_Yoru.Paint(e.Graphics);
            this.BtnFugo_Hiku.Paint(e.Graphics);
            this.BtnFugo_Agaru.Paint(e.Graphics);
            this.BtnFugo_Migi.Paint(e.Graphics);
            this.BtnFugo_Hidari.Paint(e.Graphics);
            this.BtnFugo_Sugu.Paint(e.Graphics);
            this.BtnFugo_Nari.Paint(e.Graphics);
            this.BtnFugo_Funari.Paint(e.Graphics);
            this.BtnFugo_Da.Paint(e.Graphics);
            this.BtnFugo_Zenkesi.Paint(e.Graphics);

            //----------
            // 先後表示
            //----------
            this.LblSengo.Paint(e.Graphics);

            //----------
            // 符号表示
            //----------
            this.LblFugo.Paint(e.Graphics);
        }

        private void Uc_Main_MouseMove(object sender, MouseEventArgs e)
        {
            //----------
            // 将棋盤：升目
            //----------
            foreach (Button_Masu cell in this.Shogiban.MasuList)
            {
                cell.LightByMouse(e.Location.X, e.Location.Y);
                if (cell.Light)
                {
                    this.Refresh();
                }
            }

            //----------
            // 駒置き：升目
            //----------
            foreach (Komadai komaoki in this.KomadaiArr)
            {
                foreach (Button_Masu cell in komaoki.MasuList)
                {
                    cell.LightByMouse(e.Location.X, e.Location.Y);
                    if (cell.Light)
                    {
                        this.Refresh();
                    }
                }
            }

            //----------
            // 駒
            //----------
            foreach (Button_Koma koma in this.KomaCollection.Kyokumen.Items)
            {
                koma.LightByMouse(e.Location.X, e.Location.Y);
                if (koma.Light)
                {
                    this.Refresh();
                }
            }

            //----------
            // 成るボタン
            //----------
            {
                this.BtnNaru.LightByMouse(e.Location.X, e.Location.Y);
                if (this.BtnNaru.Light)
                {
                    this.Refresh();
                }
            }

            //----------
            // 向きボタン
            //----------
            {
                this.BtnMuki.LightByMouse(e.Location.X, e.Location.Y);
                if (this.BtnMuki.Light)
                {
                    this.Refresh();
                }
            }

            //----------
            // 初期配置ボタン
            //----------
            {
                this.BtnSyokihaichi.LightByMouse(e.Location.X, e.Location.Y);
                if (this.BtnSyokihaichi.Light)
                {
                    this.Refresh();
                }
            }

            //----------
            // クリアーボタン
            //----------
            {
                this.BtnClear.LightByMouse(e.Location.X, e.Location.Y);
                if (this.BtnClear.Light)
                {
                    this.Refresh();
                }
            }

            //----------
            // HTMLボタン
            //----------
            {
                this.BtnHtml.LightByMouse(e.Location.X, e.Location.Y);
                if (this.BtnHtml.Light)
                {
                    this.Refresh();
                }
            }

            //----------
            // 再生ボタン
            //----------
            {
                this.BtnPlay.LightByMouse(e.Location.X, e.Location.Y);
                if (this.BtnPlay.Light)
                {
                    this.Refresh();
                }
            }

            //----------
            // コマ送りボタン
            //----------
            {
                this.BtnForward.LightByMouse(e.Location.X, e.Location.Y);
                if (this.BtnForward.Light)
                {
                    this.Refresh();
                }
            }

            //----------
            // [▲]符号ボタン
            //----------
            {
                this.BtnFugo_Sente.LightByMouse(e.Location.X, e.Location.Y); if (this.BtnFugo_Sente.Light) { this.Refresh(); }
                this.BtnFugo_Gote.LightByMouse(e.Location.X, e.Location.Y); if (this.BtnFugo_Gote.Light) { this.Refresh(); }
                this.BtnFugo_1.LightByMouse(e.Location.X, e.Location.Y); if (this.BtnFugo_1.Light) { this.Refresh(); }
                this.BtnFugo_2.LightByMouse(e.Location.X, e.Location.Y); if (this.BtnFugo_2.Light) { this.Refresh(); }
                this.BtnFugo_3.LightByMouse(e.Location.X, e.Location.Y); if (this.BtnFugo_3.Light) { this.Refresh(); }
                this.BtnFugo_4.LightByMouse(e.Location.X, e.Location.Y); if (this.BtnFugo_4.Light) { this.Refresh(); }
                this.BtnFugo_5.LightByMouse(e.Location.X, e.Location.Y); if (this.BtnFugo_5.Light) { this.Refresh(); }
                this.BtnFugo_6.LightByMouse(e.Location.X, e.Location.Y); if (this.BtnFugo_6.Light) { this.Refresh(); }
                this.BtnFugo_7.LightByMouse(e.Location.X, e.Location.Y); if (this.BtnFugo_7.Light) { this.Refresh(); }
                this.BtnFugo_8.LightByMouse(e.Location.X, e.Location.Y); if (this.BtnFugo_8.Light) { this.Refresh(); }
                this.BtnFugo_9.LightByMouse(e.Location.X, e.Location.Y); if (this.BtnFugo_9.Light) { this.Refresh(); }
                this.BtnFugo_01.LightByMouse(e.Location.X, e.Location.Y); if (this.BtnFugo_01.Light) { this.Refresh(); }
                this.BtnFugo_02.LightByMouse(e.Location.X, e.Location.Y); if (this.BtnFugo_02.Light) { this.Refresh(); }
                this.BtnFugo_03.LightByMouse(e.Location.X, e.Location.Y); if (this.BtnFugo_03.Light) { this.Refresh(); }
                this.BtnFugo_04.LightByMouse(e.Location.X, e.Location.Y); if (this.BtnFugo_04.Light) { this.Refresh(); }
                this.BtnFugo_05.LightByMouse(e.Location.X, e.Location.Y); if (this.BtnFugo_05.Light) { this.Refresh(); }
                this.BtnFugo_06.LightByMouse(e.Location.X, e.Location.Y); if (this.BtnFugo_06.Light) { this.Refresh(); }
                this.BtnFugo_07.LightByMouse(e.Location.X, e.Location.Y); if (this.BtnFugo_07.Light) { this.Refresh(); }
                this.BtnFugo_08.LightByMouse(e.Location.X, e.Location.Y); if (this.BtnFugo_08.Light) { this.Refresh(); }
                this.BtnFugo_09.LightByMouse(e.Location.X, e.Location.Y); if (this.BtnFugo_09.Light) { this.Refresh(); }
                this.BtnFugo_Dou.LightByMouse(e.Location.X, e.Location.Y); if (this.BtnFugo_Dou.Light) { this.Refresh(); }
                this.BtnFugo_Fu.LightByMouse(e.Location.X, e.Location.Y); if (this.BtnFugo_Fu.Light) { this.Refresh(); }
                this.BtnFugo_Hisya.LightByMouse(e.Location.X, e.Location.Y); if (this.BtnFugo_Hisya.Light) { this.Refresh(); }
                this.BtnFugo_Kaku.LightByMouse(e.Location.X, e.Location.Y); if (this.BtnFugo_Kaku.Light) { this.Refresh(); }
                this.BtnFugo_Kyo.LightByMouse(e.Location.X, e.Location.Y); if (this.BtnFugo_Kyo.Light) { this.Refresh(); }
                this.BtnFugo_Kei.LightByMouse(e.Location.X, e.Location.Y); if (this.BtnFugo_Kei.Light) { this.Refresh(); }
                this.BtnFugo_Gin.LightByMouse(e.Location.X, e.Location.Y); if (this.BtnFugo_Gin.Light) { this.Refresh(); }
                this.BtnFugo_Kin.LightByMouse(e.Location.X, e.Location.Y); if (this.BtnFugo_Kin.Light) { this.Refresh(); }
                this.BtnFugo_Oh.LightByMouse(e.Location.X, e.Location.Y); if (this.BtnFugo_Oh.Light) { this.Refresh(); }
                this.BtnFugo_Gyoku.LightByMouse(e.Location.X, e.Location.Y); if (this.BtnFugo_Gyoku.Light) { this.Refresh(); }
                this.BtnFugo_Tokin.LightByMouse(e.Location.X, e.Location.Y); if (this.BtnFugo_Tokin.Light) { this.Refresh(); }
                this.BtnFugo_Narikyo.LightByMouse(e.Location.X, e.Location.Y); if (this.BtnFugo_Narikyo.Light) { this.Refresh(); }
                this.BtnFugo_Narikei.LightByMouse(e.Location.X, e.Location.Y); if (this.BtnFugo_Narikei.Light) { this.Refresh(); }
                this.BtnFugo_Narigin.LightByMouse(e.Location.X, e.Location.Y); if (this.BtnFugo_Narigin.Light) { this.Refresh(); }
                this.BtnFugo_Ryu.LightByMouse(e.Location.X, e.Location.Y); if (this.BtnFugo_Ryu.Light) { this.Refresh(); }
                this.BtnFugo_Uma.LightByMouse(e.Location.X, e.Location.Y); if (this.BtnFugo_Uma.Light) { this.Refresh(); }
                this.BtnFugo_Yoru.LightByMouse(e.Location.X, e.Location.Y); if (this.BtnFugo_Yoru.Light) { this.Refresh(); }
                this.BtnFugo_Hiku.LightByMouse(e.Location.X, e.Location.Y); if (this.BtnFugo_Hiku.Light) { this.Refresh(); }
                this.BtnFugo_Agaru.LightByMouse(e.Location.X, e.Location.Y); if (this.BtnFugo_Agaru.Light) { this.Refresh(); }
                this.BtnFugo_Migi.LightByMouse(e.Location.X, e.Location.Y); if (this.BtnFugo_Migi.Light) { this.Refresh(); }
                this.BtnFugo_Hidari.LightByMouse(e.Location.X, e.Location.Y); if (this.BtnFugo_Hidari.Light) { this.Refresh(); }
                this.BtnFugo_Sugu.LightByMouse(e.Location.X, e.Location.Y); if (this.BtnFugo_Sugu.Light) { this.Refresh(); }
                this.BtnFugo_Nari.LightByMouse(e.Location.X, e.Location.Y); if (this.BtnFugo_Nari.Light) { this.Refresh(); }
                this.BtnFugo_Funari.LightByMouse(e.Location.X, e.Location.Y); if (this.BtnFugo_Funari.Light) { this.Refresh(); }
                this.BtnFugo_Da.LightByMouse(e.Location.X, e.Location.Y); if (this.BtnFugo_Da.Light) { this.Refresh(); }
                this.BtnFugo_Zenkesi.LightByMouse(e.Location.X, e.Location.Y); if (this.BtnFugo_Zenkesi.Light) { this.Refresh(); }
            }
        }

        private void Uc_Main_MouseDown(object sender, MouseEventArgs e)
        {
            if (e.Button == MouseButtons.Left)
            {
                //------------------------------------------------------------
                // 左ボタン
                //------------------------------------------------------------


                //----------
                // 既に選択されている駒
                //----------
                Button_Koma selectedBtnKoma = this.KomaCollection.FindSelectedKoma();


                //----------
                // 将棋盤：升目   ＜移動先など＞
                //----------
                if (null != selectedBtnKoma)
                {
                    // 選択されている駒があるとき
                    //>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>

                    foreach (Button_Masu btnMasu in this.Shogiban.MasuList)
                    {
                        if (btnMasu.HitByMouse(e.Location.X, e.Location.Y))
                        {
                            // 升目をクリックしたとき
                            //>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>

                            //------------------------------
                            // 駒の移動
                            //------------------------------
                            Actions_Play.MoveKoma(selectedBtnKoma, btnMasu.Masu, this);
                        }
                    }
                }

                //----------
                // 駒置き：升目
                //----------
                if (null != selectedBtnKoma)
                {
                    // 選択されている駒があるとき
                    //>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>

                    foreach (Komadai komaoki in this.KomadaiArr)
                    {
                        foreach (Button_Masu btnMasu in komaoki.MasuList)
                        {
                            if (btnMasu.HitByMouse(e.Location.X, e.Location.Y))
                            {
                                // 升目をクリックしたとき
                                //>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>

                                selectedBtnKoma.Masu.MoveTo(
                                    new MasuBango(
                                        komaoki.Sengo,// 先手の駒置きに駒を置けば、先手の向きに揃えます。
                                        btnMasu.Masu.Okiba,
                                        btnMasu.Masu.SrcOkiba,// Okiba.SHOGIBAN,
                                        btnMasu.Masu
                                        )
                                    );


                                Actions_Koma.RefreshKomaLocation(selectedBtnKoma, this.Shogiban, this.KomadaiArr, this);

                                
                                //------------------------------
                                // 成りは解除。
                                //------------------------------
                                KomaSyurui syurui2 = selectedBtnKoma.Masu.ToFunariCase();

                                selectedBtnKoma.Masu = new MasuBango(
                                    selectedBtnKoma.Masu.Sengo,
                                    selectedBtnKoma.Masu.Okiba,
                                    selectedBtnKoma.Masu.SrcOkiba,
                                    selectedBtnKoma.Masu.Suji,
                                    selectedBtnKoma.Masu.Dan,
                                    selectedBtnKoma.Masu.SrcSuji,
                                    selectedBtnKoma.Masu.SrcDan,
                                    syurui2,
                                    syurui2
                                    );


                                this.Refresh();
                            }
                        }
                    }
                }

                //----------
                // 駒
                //----------
                foreach (Button_Koma koma in this.KomaCollection.Kyokumen.Items)
                {
                    koma.SelectByMouse(e.Location.X, e.Location.Y);
                    if (koma.Selected)
                    {
                        // 新たに選択された駒があります
                        //>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>

                        this.KomaCollection.ClearAllMoverdFlag();

                        this.Refresh();
                    }
                }

                //----------
                // 成るボタン
                //----------
                {
                    if (this.BtnNaru.HitByMouse(e.Location.X, e.Location.Y))
                    {
                        Button_Koma movedKoma = this.KomaCollection.FindMovedKoma();

                        if (null != movedKoma)
                        {
                            // 移動直後の駒があるとき
                            //>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>

                            Actions_Play.Nari_KifuLast(movedKoma, this);
                            this.Refresh();
                        }
                        else if (null != selectedBtnKoma)
                        {
                            // 選択されている駒があるとき
                            //>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>

                            Actions_Play.Nari_KifuLast(selectedBtnKoma, this);
                            this.Refresh();
                        }
                    }
                }

                //----------
                // 向きボタン
                //----------

                if (this.BtnMuki.HitByMouse(e.Location.X, e.Location.Y))
                {
                    Button_Koma movedKoma = this.KomaCollection.FindMovedKoma();

                    if (null != movedKoma)
                    {
                        // 移動直後の駒があるとき
                        //>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>

                        switch (movedKoma.Masu.Sengo)
                        {
                            case Sengo.SENTE:
                                movedKoma.Masu = new MasuBango(
                                    Sengo.GOTE,
                                    movedKoma.Masu.Okiba,
                                    movedKoma.Masu.SrcOkiba,//Okiba.SHOGIBAN,
                                    movedKoma.Masu
                                    );
                                break;

                            case Sengo.GOTE:
                                movedKoma.Masu = new MasuBango(
                                    Sengo.SENTE,
                                    movedKoma.Masu.Okiba,
                                    movedKoma.Masu.SrcOkiba,//Okiba.SHOGIBAN,
                                    movedKoma.Masu
                                    );
                                break;
                        }

                        this.Refresh();
                    }
                    else if (null != selectedBtnKoma)
                    {
                        // 選択されている駒があるとき
                        //>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>

                        switch (selectedBtnKoma.Masu.Sengo)
                        {
                            case Sengo.SENTE:
                                selectedBtnKoma.Masu = new MasuBango(
                                    Sengo.GOTE,
                                    selectedBtnKoma.Masu.Okiba,
                                    selectedBtnKoma.Masu.SrcOkiba,//Okiba.SHOGIBAN,
                                    selectedBtnKoma.Masu
                                    );
                                break;

                            case Sengo.GOTE:
                                selectedBtnKoma.Masu = new MasuBango(
                                    Sengo.SENTE,
                                    selectedBtnKoma.Masu.Okiba,
                                    selectedBtnKoma.Masu.SrcOkiba,//Okiba.SHOGIBAN,
                                    selectedBtnKoma.Masu
                                    );
                                break;
                        }

                        this.Refresh();
                    }
                }

                //----------
                // 初期配置ボタン
                //----------
                if (this.BtnSyokihaichi.HitByMouse(e.Location.X, e.Location.Y))
                {
                    Actions_Kifu.Syokihaichi(this);
                    this.Refresh();
                }

                //----------
                // クリアーボタン
                //----------
                if (this.BtnClear.HitByMouse(e.Location.X, e.Location.Y))
                {
                    Actions_Kifu.Clear(this);
                    this.Refresh();
                }

                //----------
                // HTMLボタン
                //----------
                if (this.BtnHtml.HitByMouse(e.Location.X, e.Location.Y))
                {
                    Actions_Kifu.OutputHtml(this);
                    this.Refresh();
                }

                //----------
                // 再生ボタン
                //----------
                if (this.BtnPlay.HitByMouse(e.Location.X, e.Location.Y))
                {
                    Actions_Play.AppendKifu_Saisei(this);

                    //this.ClearTxtInput();
                    this.OutputKifu();

                    this.Refresh();
                }

                //----------
                // コマ送りボタン
                //----------
                if (this.BtnForward.HitByMouse(e.Location.X, e.Location.Y))
                {
                    Kifu kifuForAppend;
                    string restText;
                    Notation1Importer.TranslateTextToKifu(this.GetInputText(), out restText, out kifuForAppend, this.Kifu, this.KomaCollection, this.GameState);
                    this.SetInputText(restText);

                    Actions_Play.AppendKifu_Komaokuri(kifuForAppend, this);
                    this.Refresh();
                }

                //----------
                // [▲]～[打]符号ボタン
                //----------
                if (this.BtnFugo_Sente.HitByMouse(e.Location.X, e.Location.Y)) { this.AppendInputText("▲"); }
                if (this.BtnFugo_Gote.HitByMouse(e.Location.X, e.Location.Y)) { this.AppendInputText("△"); }
                if (this.BtnFugo_1.HitByMouse(e.Location.X, e.Location.Y)) { this.AppendInputText("１"); }
                if (this.BtnFugo_2.HitByMouse(e.Location.X, e.Location.Y)) { this.AppendInputText("２"); }
                if (this.BtnFugo_3.HitByMouse(e.Location.X, e.Location.Y)) { this.AppendInputText("３"); }
                if (this.BtnFugo_4.HitByMouse(e.Location.X, e.Location.Y)) { this.AppendInputText("４"); }
                if (this.BtnFugo_5.HitByMouse(e.Location.X, e.Location.Y)) { this.AppendInputText("５"); }
                if (this.BtnFugo_6.HitByMouse(e.Location.X, e.Location.Y)) { this.AppendInputText("６"); }
                if (this.BtnFugo_7.HitByMouse(e.Location.X, e.Location.Y)) { this.AppendInputText("７"); }
                if (this.BtnFugo_8.HitByMouse(e.Location.X, e.Location.Y)) { this.AppendInputText("８"); }
                if (this.BtnFugo_9.HitByMouse(e.Location.X, e.Location.Y)) { this.AppendInputText("９"); }
                if (this.BtnFugo_01.HitByMouse(e.Location.X, e.Location.Y)) { this.AppendInputText("一"); }
                if (this.BtnFugo_02.HitByMouse(e.Location.X, e.Location.Y)) { this.AppendInputText("二"); }
                if (this.BtnFugo_03.HitByMouse(e.Location.X, e.Location.Y)) { this.AppendInputText("三"); }
                if (this.BtnFugo_04.HitByMouse(e.Location.X, e.Location.Y)) { this.AppendInputText("四"); }
                if (this.BtnFugo_05.HitByMouse(e.Location.X, e.Location.Y)) { this.AppendInputText("五"); }
                if (this.BtnFugo_06.HitByMouse(e.Location.X, e.Location.Y)) { this.AppendInputText("六"); }
                if (this.BtnFugo_07.HitByMouse(e.Location.X, e.Location.Y)) { this.AppendInputText("七"); }
                if (this.BtnFugo_08.HitByMouse(e.Location.X, e.Location.Y)) { this.AppendInputText("八"); }
                if (this.BtnFugo_09.HitByMouse(e.Location.X, e.Location.Y)) { this.AppendInputText("九"); }
                if (this.BtnFugo_Dou.HitByMouse(e.Location.X, e.Location.Y)) { this.AppendInputText("同"); }
                if (this.BtnFugo_Fu.HitByMouse(e.Location.X, e.Location.Y)) { this.AppendInputText("歩"); }
                if (this.BtnFugo_Hisya.HitByMouse(e.Location.X, e.Location.Y)) { this.AppendInputText("飛"); }
                if (this.BtnFugo_Kaku.HitByMouse(e.Location.X, e.Location.Y)) { this.AppendInputText("角"); }
                if (this.BtnFugo_Kyo.HitByMouse(e.Location.X, e.Location.Y)) { this.AppendInputText("香"); }
                if (this.BtnFugo_Kei.HitByMouse(e.Location.X, e.Location.Y)) { this.AppendInputText("桂"); }
                if (this.BtnFugo_Gin.HitByMouse(e.Location.X, e.Location.Y)) { this.AppendInputText("銀"); }
                if (this.BtnFugo_Kin.HitByMouse(e.Location.X, e.Location.Y)) { this.AppendInputText("金"); }
                if (this.BtnFugo_Oh.HitByMouse(e.Location.X, e.Location.Y)) { this.AppendInputText("王"); }
                if (this.BtnFugo_Gyoku.HitByMouse(e.Location.X, e.Location.Y)) { this.AppendInputText("玉"); }
                if (this.BtnFugo_Tokin.HitByMouse(e.Location.X, e.Location.Y)) { this.AppendInputText("と"); }
                if (this.BtnFugo_Narikyo.HitByMouse(e.Location.X, e.Location.Y)) { this.AppendInputText("成香"); }
                if (this.BtnFugo_Narikei.HitByMouse(e.Location.X, e.Location.Y)) { this.AppendInputText("成桂"); }
                if (this.BtnFugo_Narigin.HitByMouse(e.Location.X, e.Location.Y)) { this.AppendInputText("成銀"); }
                if (this.BtnFugo_Ryu.HitByMouse(e.Location.X, e.Location.Y)) { this.AppendInputText("竜"); }
                if (this.BtnFugo_Uma.HitByMouse(e.Location.X, e.Location.Y)) { this.AppendInputText("馬"); }
                if (this.BtnFugo_Yoru.HitByMouse(e.Location.X, e.Location.Y)) { this.AppendInputText("寄"); }
                if (this.BtnFugo_Hiku.HitByMouse(e.Location.X, e.Location.Y)) { this.AppendInputText("引"); }
                if (this.BtnFugo_Agaru.HitByMouse(e.Location.X, e.Location.Y)) { this.AppendInputText("上"); }
                if (this.BtnFugo_Migi.HitByMouse(e.Location.X, e.Location.Y)) { this.AppendInputText("右"); }
                if (this.BtnFugo_Hidari.HitByMouse(e.Location.X, e.Location.Y)) { this.AppendInputText("左"); }
                if (this.BtnFugo_Sugu.HitByMouse(e.Location.X, e.Location.Y)) { this.AppendInputText("直"); }
                if (this.BtnFugo_Nari.HitByMouse(e.Location.X, e.Location.Y)) { this.AppendInputText("成"); }
                if (this.BtnFugo_Funari.HitByMouse(e.Location.X, e.Location.Y)) { this.AppendInputText("不成"); }
                if (this.BtnFugo_Da.HitByMouse(e.Location.X, e.Location.Y)) { this.AppendInputText("打"); }
                if (this.BtnFugo_Zenkesi.HitByMouse(e.Location.X, e.Location.Y)) { this.ClearTxtInput(); }
            }
            else if (e.Button == MouseButtons.Right)
            {
                //------------------------------------------------------------
                // 右ボタン
                //------------------------------------------------------------
                this.KomaCollection.ClearAllSelectedFlag();
            }
        }

        private void Uc_Main_MouseUp(object sender, MouseEventArgs e)
        {
            if (e.Button == MouseButtons.Left)
            {
                //------------------------------------------------------------
                // 左ボタン
                //------------------------------------------------------------


                //----------
                // 将棋盤：升目
                //----------
                foreach (Button_Masu cell in this.Shogiban.MasuList)
                {
                    if (cell.DeselectByMouse(e.Location.X, e.Location.Y))
                    {
                        this.Refresh();
                    }
                }

                //----------
                // 駒置き：升目
                //----------
                foreach (Komadai komaoki in this.KomadaiArr)
                {
                    foreach (Button_Masu cell in komaoki.MasuList)
                    {
                        if (cell.DeselectByMouse(e.Location.X, e.Location.Y))
                        {
                            this.Refresh();
                        }
                    }
                }

                //----------
                // 駒
                //----------
                foreach (Button_Koma k in this.KomaCollection.Kyokumen.Items)
                {
                    if (k.HitByMouse(e.Location.X, e.Location.Y))
                    {
                        // マウスが重なっていました
                        //>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>

                        if (k.Deselect())
                        {
                            // 駒から指を放しました
                            //>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>

                            if (k.Masu.DoneMove())
                            {
                                // 駒は、移動しました。
                                //>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>

                                //----------
                                // 移動済表示
                                //----------
                                k.Moved = true;

                                //------------------------------
                                // マウスで棋譜に符号を追加
                                //------------------------------
                                MasuBango previousMasu = this.Kifu.Last;
                                MasuBango newMasuBango;
                                this.Kifu.AddAndRefresh(
                                    new MasuBango(this.GameState.Sengo, k.Masu.Okiba, k.Masu.SrcOkiba, k.Masu),// 選択している駒の元の場所と、移動先
                                    out newMasuBango
                                    );


                                //------------------------------
                                // 符号表示
                                //------------------------------
                                View_Fugo fugoView = Translator_MasuToFugo1.TranslateMasuToFugo1(newMasuBango, this.KomaCollection, this.Kifu);
                                this.LblFugo.Text = fugoView.ToString(true, newMasuBango, previousMasu);


                                //------------------------------
                                // 先後切替
                                //------------------------------
                                //
                                //      先手の駒を放すと後手番に、後手の駒を放すと先手番にします。
                                //
                                MasuBango last = this.Kifu.Last;
                                this.GameState.ChangeTurn(last.Suji, last.Dan, this);


                                //------------------------------
                                // 棋譜出力
                                //------------------------------
                                this.OutputKifu();


                                this.Refresh();
                            }
                        }
                    }
                }

                //----------
                // 成るボタン
                //----------
                {
                    if (this.BtnNaru.DeselectByMouse(e.Location.X, e.Location.Y))
                    {
                        this.Refresh();
                    }
                }

                //----------
                // 向きボタン
                //----------
                {
                    if (this.BtnMuki.DeselectByMouse(e.Location.X, e.Location.Y))
                    {
                        this.Refresh();
                    }
                }

                //----------
                // 初期配置ボタン
                //----------
                {
                    if (this.BtnSyokihaichi.DeselectByMouse(e.Location.X, e.Location.Y))
                    {
                        this.Refresh();
                    }
                }

                //----------
                // クリアーボタン
                //----------
                {
                    if (this.BtnClear.DeselectByMouse(e.Location.X, e.Location.Y))
                    {
                        this.Refresh();
                    }
                }

                //----------
                // HTMLボタン
                //----------
                {
                    if (this.BtnHtml.DeselectByMouse(e.Location.X, e.Location.Y))
                    {
                        this.Refresh();
                    }
                }

                //----------
                // 再生ボタン
                //----------
                {
                    if (this.BtnPlay.DeselectByMouse(e.Location.X, e.Location.Y))
                    {
                        this.Refresh();
                    }
                }

                //----------
                // コマ送りボタン
                //----------
                {
                    if (this.BtnForward.DeselectByMouse(e.Location.X, e.Location.Y))
                    {
                        this.Refresh();
                    }
                }

                //----------
                // [▲]～[打]符号ボタン
                //----------
                {
                    if (this.BtnFugo_Sente.DeselectByMouse(e.Location.X, e.Location.Y)){this.Refresh();}
                    if (this.BtnFugo_Gote.DeselectByMouse(e.Location.X, e.Location.Y)) { this.Refresh(); }
                    if (this.BtnFugo_1.DeselectByMouse(e.Location.X, e.Location.Y)) { this.Refresh(); }
                    if (this.BtnFugo_2.DeselectByMouse(e.Location.X, e.Location.Y)) { this.Refresh(); }
                    if (this.BtnFugo_3.DeselectByMouse(e.Location.X, e.Location.Y)) { this.Refresh(); }
                    if (this.BtnFugo_4.DeselectByMouse(e.Location.X, e.Location.Y)) { this.Refresh(); }
                    if (this.BtnFugo_5.DeselectByMouse(e.Location.X, e.Location.Y)) { this.Refresh(); }
                    if (this.BtnFugo_6.DeselectByMouse(e.Location.X, e.Location.Y)) { this.Refresh(); }
                    if (this.BtnFugo_7.DeselectByMouse(e.Location.X, e.Location.Y)) { this.Refresh(); }
                    if (this.BtnFugo_8.DeselectByMouse(e.Location.X, e.Location.Y)) { this.Refresh(); }
                    if (this.BtnFugo_9.DeselectByMouse(e.Location.X, e.Location.Y)) { this.Refresh(); }
                    if (this.BtnFugo_01.DeselectByMouse(e.Location.X, e.Location.Y)) { this.Refresh(); }
                    if (this.BtnFugo_02.DeselectByMouse(e.Location.X, e.Location.Y)) { this.Refresh(); }
                    if (this.BtnFugo_03.DeselectByMouse(e.Location.X, e.Location.Y)) { this.Refresh(); }
                    if (this.BtnFugo_04.DeselectByMouse(e.Location.X, e.Location.Y)) { this.Refresh(); }
                    if (this.BtnFugo_05.DeselectByMouse(e.Location.X, e.Location.Y)) { this.Refresh(); }
                    if (this.BtnFugo_06.DeselectByMouse(e.Location.X, e.Location.Y)) { this.Refresh(); }
                    if (this.BtnFugo_07.DeselectByMouse(e.Location.X, e.Location.Y)) { this.Refresh(); }
                    if (this.BtnFugo_08.DeselectByMouse(e.Location.X, e.Location.Y)) { this.Refresh(); }
                    if (this.BtnFugo_09.DeselectByMouse(e.Location.X, e.Location.Y)) { this.Refresh(); }
                    if (this.BtnFugo_Dou.DeselectByMouse(e.Location.X, e.Location.Y)) { this.Refresh(); }
                    if (this.BtnFugo_Fu.DeselectByMouse(e.Location.X, e.Location.Y)) { this.Refresh(); }
                    if (this.BtnFugo_Hisya.DeselectByMouse(e.Location.X, e.Location.Y)) { this.Refresh(); }
                    if (this.BtnFugo_Kaku.DeselectByMouse(e.Location.X, e.Location.Y)) { this.Refresh(); }
                    if (this.BtnFugo_Kyo.DeselectByMouse(e.Location.X, e.Location.Y)) { this.Refresh(); }
                    if (this.BtnFugo_Kei.DeselectByMouse(e.Location.X, e.Location.Y)) { this.Refresh(); }
                    if (this.BtnFugo_Gin.DeselectByMouse(e.Location.X, e.Location.Y)) { this.Refresh(); }
                    if (this.BtnFugo_Kin.DeselectByMouse(e.Location.X, e.Location.Y)) { this.Refresh(); }
                    if (this.BtnFugo_Oh.DeselectByMouse(e.Location.X, e.Location.Y)) { this.Refresh(); }
                    if (this.BtnFugo_Gyoku.DeselectByMouse(e.Location.X, e.Location.Y)) { this.Refresh(); }
                    if (this.BtnFugo_Tokin.DeselectByMouse(e.Location.X, e.Location.Y)) { this.Refresh(); }
                    if (this.BtnFugo_Narikyo.DeselectByMouse(e.Location.X, e.Location.Y)) { this.Refresh(); }
                    if (this.BtnFugo_Narikei.DeselectByMouse(e.Location.X, e.Location.Y)) { this.Refresh(); }
                    if (this.BtnFugo_Narigin.DeselectByMouse(e.Location.X, e.Location.Y)) { this.Refresh(); }
                    if (this.BtnFugo_Ryu.DeselectByMouse(e.Location.X, e.Location.Y)) { this.Refresh(); }
                    if (this.BtnFugo_Uma.DeselectByMouse(e.Location.X, e.Location.Y)) { this.Refresh(); }
                    if (this.BtnFugo_Yoru.DeselectByMouse(e.Location.X, e.Location.Y)) { this.Refresh(); }
                    if (this.BtnFugo_Hiku.DeselectByMouse(e.Location.X, e.Location.Y)) { this.Refresh(); }
                    if (this.BtnFugo_Agaru.DeselectByMouse(e.Location.X, e.Location.Y)) { this.Refresh(); }
                    if (this.BtnFugo_Migi.DeselectByMouse(e.Location.X, e.Location.Y)) { this.Refresh(); }
                    if (this.BtnFugo_Hidari.DeselectByMouse(e.Location.X, e.Location.Y)) { this.Refresh(); }
                    if (this.BtnFugo_Sugu.DeselectByMouse(e.Location.X, e.Location.Y)) { this.Refresh(); }
                    if (this.BtnFugo_Nari.DeselectByMouse(e.Location.X, e.Location.Y)) { this.Refresh(); }
                    if (this.BtnFugo_Funari.DeselectByMouse(e.Location.X, e.Location.Y)) { this.Refresh(); }
                    if (this.BtnFugo_Da.DeselectByMouse(e.Location.X, e.Location.Y)) { this.Refresh(); }
                    if (this.BtnFugo_Zenkesi.DeselectByMouse(e.Location.X, e.Location.Y)) { this.Refresh(); }
                }
            }
            else if (e.Button == MouseButtons.Right)
            {
                //------------------------------------------------------------
                // 右ボタン
                //------------------------------------------------------------
            }

        }

        public void ClearTxtInput()
        {
            this.txtInput1.Text = "";
        }

        public void ClearTxtOutput()
        {
            this.txtOutput1.Text = "";
        }

        public void SetTxtOutput(string value)
        {
            this.txtOutput1.Text = value;
        }

        public string GetTxtOutput()
        {
            return this.txtOutput1.Text;
        }

        private void txtStandard_KeyDown(object sender, KeyEventArgs e)
        {
            if (e.KeyCode == System.Windows.Forms.Keys.A & e.Control == true)
            {
                ((TextBox)sender).SelectAll();
            } 
        }

        /// <summary>
        /// 符号の記憶を消去します。
        /// </summary>
        public void ClearFugoList_Kiroku()
        {
            this.Kifu.Clear();
        }
    }
}
